package org.eclipse.lsat.dispatching.teditor.parser.antlr.internal;

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import org.eclipse.lsat.dispatching.teditor.services.DispatchingGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
/**
 * Copyright (c) 2021 Contributors to the Eclipse Foundation
 *
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Do not edit: This file is generated by Xtext
 */
@SuppressWarnings("all")
public class InternalDispatchingParser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_INT", "RULE_ID", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'throughput'", "'{'", "'iterations'", "':'", "'}'", "'.'", "'activities'", "'('", "','", "')'", "'repeat'", "'['", "']'", "'yield'", "'offset'", "'..'", "'='", "'import'", "'-'", "'E'", "'e'"
    };
    public static final int RULE_STRING=6;
    public static final int RULE_SL_COMMENT=8;
    public static final int T__19=19;
    public static final int T__15=15;
    public static final int T__16=16;
    public static final int T__17=17;
    public static final int T__18=18;
    public static final int T__11=11;
    public static final int T__12=12;
    public static final int T__13=13;
    public static final int T__14=14;
    public static final int EOF=-1;
    public static final int T__30=30;
    public static final int T__31=31;
    public static final int RULE_ID=5;
    public static final int RULE_WS=9;
    public static final int RULE_ANY_OTHER=10;
    public static final int T__26=26;
    public static final int T__27=27;
    public static final int T__28=28;
    public static final int RULE_INT=4;
    public static final int T__29=29;
    public static final int T__22=22;
    public static final int RULE_ML_COMMENT=7;
    public static final int T__23=23;
    public static final int T__24=24;
    public static final int T__25=25;
    public static final int T__20=20;
    public static final int T__21=21;

    // delegates
    // delegators


        public InternalDispatchingParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalDispatchingParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalDispatchingParser.tokenNames; }
    public String getGrammarFileName() { return "InternalDispatching.g"; }



     	private DispatchingGrammarAccess grammarAccess;

        public InternalDispatchingParser(TokenStream input, DispatchingGrammarAccess grammarAccess) {
            this(input);
            this.grammarAccess = grammarAccess;
            registerRules(grammarAccess.getGrammar());
        }

        @Override
        protected String getFirstRuleName() {
        	return "ActivityDispatching";
       	}

       	@Override
       	protected DispatchingGrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}




    // $ANTLR start "entryRuleActivityDispatching"
    // InternalDispatching.g:72:1: entryRuleActivityDispatching returns [EObject current=null] : iv_ruleActivityDispatching= ruleActivityDispatching EOF ;
    public final EObject entryRuleActivityDispatching() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleActivityDispatching = null;


        try {
            // InternalDispatching.g:72:60: (iv_ruleActivityDispatching= ruleActivityDispatching EOF )
            // InternalDispatching.g:73:2: iv_ruleActivityDispatching= ruleActivityDispatching EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getActivityDispatchingRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleActivityDispatching=ruleActivityDispatching();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleActivityDispatching; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleActivityDispatching"


    // $ANTLR start "ruleActivityDispatching"
    // InternalDispatching.g:79:1: ruleActivityDispatching returns [EObject current=null] : ( () ( (lv_imports_1_0= ruleImport ) )* (otherlv_2= 'throughput' otherlv_3= '{' (otherlv_4= 'iterations' otherlv_5= ':' ( (lv_numberOfIterations_6_0= RULE_INT ) ) )? ( (lv_resourceIterations_7_0= ruleResourceIterationsMapEntry ) )* otherlv_8= '}' )? ( (lv_dispatchGroups_9_0= ruleDispatchGroup ) )* ) ;
    public final EObject ruleActivityDispatching() throws RecognitionException {
        EObject current = null;

        Token otherlv_2=null;
        Token otherlv_3=null;
        Token otherlv_4=null;
        Token otherlv_5=null;
        Token lv_numberOfIterations_6_0=null;
        Token otherlv_8=null;
        EObject lv_imports_1_0 = null;

        EObject lv_resourceIterations_7_0 = null;

        EObject lv_dispatchGroups_9_0 = null;



        	enterRule();

        try {
            // InternalDispatching.g:85:2: ( ( () ( (lv_imports_1_0= ruleImport ) )* (otherlv_2= 'throughput' otherlv_3= '{' (otherlv_4= 'iterations' otherlv_5= ':' ( (lv_numberOfIterations_6_0= RULE_INT ) ) )? ( (lv_resourceIterations_7_0= ruleResourceIterationsMapEntry ) )* otherlv_8= '}' )? ( (lv_dispatchGroups_9_0= ruleDispatchGroup ) )* ) )
            // InternalDispatching.g:86:2: ( () ( (lv_imports_1_0= ruleImport ) )* (otherlv_2= 'throughput' otherlv_3= '{' (otherlv_4= 'iterations' otherlv_5= ':' ( (lv_numberOfIterations_6_0= RULE_INT ) ) )? ( (lv_resourceIterations_7_0= ruleResourceIterationsMapEntry ) )* otherlv_8= '}' )? ( (lv_dispatchGroups_9_0= ruleDispatchGroup ) )* )
            {
            // InternalDispatching.g:86:2: ( () ( (lv_imports_1_0= ruleImport ) )* (otherlv_2= 'throughput' otherlv_3= '{' (otherlv_4= 'iterations' otherlv_5= ':' ( (lv_numberOfIterations_6_0= RULE_INT ) ) )? ( (lv_resourceIterations_7_0= ruleResourceIterationsMapEntry ) )* otherlv_8= '}' )? ( (lv_dispatchGroups_9_0= ruleDispatchGroup ) )* )
            // InternalDispatching.g:87:3: () ( (lv_imports_1_0= ruleImport ) )* (otherlv_2= 'throughput' otherlv_3= '{' (otherlv_4= 'iterations' otherlv_5= ':' ( (lv_numberOfIterations_6_0= RULE_INT ) ) )? ( (lv_resourceIterations_7_0= ruleResourceIterationsMapEntry ) )* otherlv_8= '}' )? ( (lv_dispatchGroups_9_0= ruleDispatchGroup ) )*
            {
            // InternalDispatching.g:87:3: ()
            // InternalDispatching.g:88:4: 
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getActivityDispatchingAccess().getActivityDispatchingAction_0(),
              					current);
              			
            }

            }

            // InternalDispatching.g:94:3: ( (lv_imports_1_0= ruleImport ) )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==28) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // InternalDispatching.g:95:4: (lv_imports_1_0= ruleImport )
            	    {
            	    // InternalDispatching.g:95:4: (lv_imports_1_0= ruleImport )
            	    // InternalDispatching.g:96:5: lv_imports_1_0= ruleImport
            	    {
            	    if ( state.backtracking==0 ) {

            	      					newCompositeNode(grammarAccess.getActivityDispatchingAccess().getImportsImportParserRuleCall_1_0());
            	      				
            	    }
            	    pushFollow(FOLLOW_3);
            	    lv_imports_1_0=ruleImport();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      					if (current==null) {
            	      						current = createModelElementForParent(grammarAccess.getActivityDispatchingRule());
            	      					}
            	      					add(
            	      						current,
            	      						"imports",
            	      						lv_imports_1_0,
            	      						"org.eclipse.lsat.dispatching.teditor.Dispatching.Import");
            	      					afterParserOrEnumRuleCall();
            	      				
            	    }

            	    }


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);

            // InternalDispatching.g:113:3: (otherlv_2= 'throughput' otherlv_3= '{' (otherlv_4= 'iterations' otherlv_5= ':' ( (lv_numberOfIterations_6_0= RULE_INT ) ) )? ( (lv_resourceIterations_7_0= ruleResourceIterationsMapEntry ) )* otherlv_8= '}' )?
            int alt4=2;
            int LA4_0 = input.LA(1);

            if ( (LA4_0==11) ) {
                alt4=1;
            }
            switch (alt4) {
                case 1 :
                    // InternalDispatching.g:114:4: otherlv_2= 'throughput' otherlv_3= '{' (otherlv_4= 'iterations' otherlv_5= ':' ( (lv_numberOfIterations_6_0= RULE_INT ) ) )? ( (lv_resourceIterations_7_0= ruleResourceIterationsMapEntry ) )* otherlv_8= '}'
                    {
                    otherlv_2=(Token)match(input,11,FOLLOW_4); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_2, grammarAccess.getActivityDispatchingAccess().getThroughputKeyword_2_0());
                      			
                    }
                    otherlv_3=(Token)match(input,12,FOLLOW_5); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_3, grammarAccess.getActivityDispatchingAccess().getLeftCurlyBracketKeyword_2_1());
                      			
                    }
                    // InternalDispatching.g:122:4: (otherlv_4= 'iterations' otherlv_5= ':' ( (lv_numberOfIterations_6_0= RULE_INT ) ) )?
                    int alt2=2;
                    int LA2_0 = input.LA(1);

                    if ( (LA2_0==13) ) {
                        int LA2_1 = input.LA(2);

                        if ( (LA2_1==14) ) {
                            alt2=1;
                        }
                    }
                    switch (alt2) {
                        case 1 :
                            // InternalDispatching.g:123:5: otherlv_4= 'iterations' otherlv_5= ':' ( (lv_numberOfIterations_6_0= RULE_INT ) )
                            {
                            otherlv_4=(Token)match(input,13,FOLLOW_6); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              					newLeafNode(otherlv_4, grammarAccess.getActivityDispatchingAccess().getIterationsKeyword_2_2_0());
                              				
                            }
                            otherlv_5=(Token)match(input,14,FOLLOW_7); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              					newLeafNode(otherlv_5, grammarAccess.getActivityDispatchingAccess().getColonKeyword_2_2_1());
                              				
                            }
                            // InternalDispatching.g:131:5: ( (lv_numberOfIterations_6_0= RULE_INT ) )
                            // InternalDispatching.g:132:6: (lv_numberOfIterations_6_0= RULE_INT )
                            {
                            // InternalDispatching.g:132:6: (lv_numberOfIterations_6_0= RULE_INT )
                            // InternalDispatching.g:133:7: lv_numberOfIterations_6_0= RULE_INT
                            {
                            lv_numberOfIterations_6_0=(Token)match(input,RULE_INT,FOLLOW_5); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              							newLeafNode(lv_numberOfIterations_6_0, grammarAccess.getActivityDispatchingAccess().getNumberOfIterationsINTTerminalRuleCall_2_2_2_0());
                              						
                            }
                            if ( state.backtracking==0 ) {

                              							if (current==null) {
                              								current = createModelElement(grammarAccess.getActivityDispatchingRule());
                              							}
                              							setWithLastConsumed(
                              								current,
                              								"numberOfIterations",
                              								lv_numberOfIterations_6_0,
                              								"org.eclipse.xtext.common.Terminals.INT");
                              						
                            }

                            }


                            }


                            }
                            break;

                    }

                    // InternalDispatching.g:150:4: ( (lv_resourceIterations_7_0= ruleResourceIterationsMapEntry ) )*
                    loop3:
                    do {
                        int alt3=2;
                        int LA3_0 = input.LA(1);

                        if ( (LA3_0==13) ) {
                            alt3=1;
                        }


                        switch (alt3) {
                    	case 1 :
                    	    // InternalDispatching.g:151:5: (lv_resourceIterations_7_0= ruleResourceIterationsMapEntry )
                    	    {
                    	    // InternalDispatching.g:151:5: (lv_resourceIterations_7_0= ruleResourceIterationsMapEntry )
                    	    // InternalDispatching.g:152:6: lv_resourceIterations_7_0= ruleResourceIterationsMapEntry
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      						newCompositeNode(grammarAccess.getActivityDispatchingAccess().getResourceIterationsResourceIterationsMapEntryParserRuleCall_2_3_0());
                    	      					
                    	    }
                    	    pushFollow(FOLLOW_5);
                    	    lv_resourceIterations_7_0=ruleResourceIterationsMapEntry();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      						if (current==null) {
                    	      							current = createModelElementForParent(grammarAccess.getActivityDispatchingRule());
                    	      						}
                    	      						add(
                    	      							current,
                    	      							"resourceIterations",
                    	      							lv_resourceIterations_7_0,
                    	      							"org.eclipse.lsat.dispatching.teditor.Dispatching.ResourceIterationsMapEntry");
                    	      						afterParserOrEnumRuleCall();
                    	      					
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop3;
                        }
                    } while (true);

                    otherlv_8=(Token)match(input,15,FOLLOW_8); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_8, grammarAccess.getActivityDispatchingAccess().getRightCurlyBracketKeyword_2_4());
                      			
                    }

                    }
                    break;

            }

            // InternalDispatching.g:174:3: ( (lv_dispatchGroups_9_0= ruleDispatchGroup ) )*
            loop5:
            do {
                int alt5=2;
                int LA5_0 = input.LA(1);

                if ( (LA5_0==17) ) {
                    alt5=1;
                }


                switch (alt5) {
            	case 1 :
            	    // InternalDispatching.g:175:4: (lv_dispatchGroups_9_0= ruleDispatchGroup )
            	    {
            	    // InternalDispatching.g:175:4: (lv_dispatchGroups_9_0= ruleDispatchGroup )
            	    // InternalDispatching.g:176:5: lv_dispatchGroups_9_0= ruleDispatchGroup
            	    {
            	    if ( state.backtracking==0 ) {

            	      					newCompositeNode(grammarAccess.getActivityDispatchingAccess().getDispatchGroupsDispatchGroupParserRuleCall_3_0());
            	      				
            	    }
            	    pushFollow(FOLLOW_8);
            	    lv_dispatchGroups_9_0=ruleDispatchGroup();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      					if (current==null) {
            	      						current = createModelElementForParent(grammarAccess.getActivityDispatchingRule());
            	      					}
            	      					add(
            	      						current,
            	      						"dispatchGroups",
            	      						lv_dispatchGroups_9_0,
            	      						"org.eclipse.lsat.dispatching.teditor.Dispatching.DispatchGroup");
            	      					afterParserOrEnumRuleCall();
            	      				
            	    }

            	    }


            	    }
            	    break;

            	default :
            	    break loop5;
                }
            } while (true);


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleActivityDispatching"


    // $ANTLR start "entryRuleResourceIterationsMapEntry"
    // InternalDispatching.g:197:1: entryRuleResourceIterationsMapEntry returns [EObject current=null] : iv_ruleResourceIterationsMapEntry= ruleResourceIterationsMapEntry EOF ;
    public final EObject entryRuleResourceIterationsMapEntry() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleResourceIterationsMapEntry = null;


        try {
            // InternalDispatching.g:197:67: (iv_ruleResourceIterationsMapEntry= ruleResourceIterationsMapEntry EOF )
            // InternalDispatching.g:198:2: iv_ruleResourceIterationsMapEntry= ruleResourceIterationsMapEntry EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getResourceIterationsMapEntryRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleResourceIterationsMapEntry=ruleResourceIterationsMapEntry();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleResourceIterationsMapEntry; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleResourceIterationsMapEntry"


    // $ANTLR start "ruleResourceIterationsMapEntry"
    // InternalDispatching.g:204:1: ruleResourceIterationsMapEntry returns [EObject current=null] : (otherlv_0= 'iterations' otherlv_1= '.' ( ( ruleResourceQualifiedName ) ) otherlv_3= ':' ( (lv_value_4_0= RULE_INT ) ) ) ;
    public final EObject ruleResourceIterationsMapEntry() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_1=null;
        Token otherlv_3=null;
        Token lv_value_4_0=null;


        	enterRule();

        try {
            // InternalDispatching.g:210:2: ( (otherlv_0= 'iterations' otherlv_1= '.' ( ( ruleResourceQualifiedName ) ) otherlv_3= ':' ( (lv_value_4_0= RULE_INT ) ) ) )
            // InternalDispatching.g:211:2: (otherlv_0= 'iterations' otherlv_1= '.' ( ( ruleResourceQualifiedName ) ) otherlv_3= ':' ( (lv_value_4_0= RULE_INT ) ) )
            {
            // InternalDispatching.g:211:2: (otherlv_0= 'iterations' otherlv_1= '.' ( ( ruleResourceQualifiedName ) ) otherlv_3= ':' ( (lv_value_4_0= RULE_INT ) ) )
            // InternalDispatching.g:212:3: otherlv_0= 'iterations' otherlv_1= '.' ( ( ruleResourceQualifiedName ) ) otherlv_3= ':' ( (lv_value_4_0= RULE_INT ) )
            {
            otherlv_0=(Token)match(input,13,FOLLOW_9); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_0, grammarAccess.getResourceIterationsMapEntryAccess().getIterationsKeyword_0());
              		
            }
            otherlv_1=(Token)match(input,16,FOLLOW_10); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_1, grammarAccess.getResourceIterationsMapEntryAccess().getFullStopKeyword_1());
              		
            }
            // InternalDispatching.g:220:3: ( ( ruleResourceQualifiedName ) )
            // InternalDispatching.g:221:4: ( ruleResourceQualifiedName )
            {
            // InternalDispatching.g:221:4: ( ruleResourceQualifiedName )
            // InternalDispatching.g:222:5: ruleResourceQualifiedName
            {
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElement(grammarAccess.getResourceIterationsMapEntryRule());
              					}
              				
            }
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getResourceIterationsMapEntryAccess().getKeyIResourceCrossReference_2_0());
              				
            }
            pushFollow(FOLLOW_6);
            ruleResourceQualifiedName();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            otherlv_3=(Token)match(input,14,FOLLOW_7); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_3, grammarAccess.getResourceIterationsMapEntryAccess().getColonKeyword_3());
              		
            }
            // InternalDispatching.g:240:3: ( (lv_value_4_0= RULE_INT ) )
            // InternalDispatching.g:241:4: (lv_value_4_0= RULE_INT )
            {
            // InternalDispatching.g:241:4: (lv_value_4_0= RULE_INT )
            // InternalDispatching.g:242:5: lv_value_4_0= RULE_INT
            {
            lv_value_4_0=(Token)match(input,RULE_INT,FOLLOW_2); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					newLeafNode(lv_value_4_0, grammarAccess.getResourceIterationsMapEntryAccess().getValueINTTerminalRuleCall_4_0());
              				
            }
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElement(grammarAccess.getResourceIterationsMapEntryRule());
              					}
              					setWithLastConsumed(
              						current,
              						"value",
              						lv_value_4_0,
              						"org.eclipse.xtext.common.Terminals.INT");
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleResourceIterationsMapEntry"


    // $ANTLR start "entryRuleDispatchGroup"
    // InternalDispatching.g:262:1: entryRuleDispatchGroup returns [EObject current=null] : iv_ruleDispatchGroup= ruleDispatchGroup EOF ;
    public final EObject entryRuleDispatchGroup() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleDispatchGroup = null;


        try {
            // InternalDispatching.g:262:54: (iv_ruleDispatchGroup= ruleDispatchGroup EOF )
            // InternalDispatching.g:263:2: iv_ruleDispatchGroup= ruleDispatchGroup EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getDispatchGroupRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleDispatchGroup=ruleDispatchGroup();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleDispatchGroup; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleDispatchGroup"


    // $ANTLR start "ruleDispatchGroup"
    // InternalDispatching.g:269:1: ruleDispatchGroup returns [EObject current=null] : ( () otherlv_1= 'activities' ( (lv_name_2_0= ruleIDString ) )? (otherlv_3= '(' ( ( (lv_userAttributes_4_0= ruleAttributesMapEntry ) ) (otherlv_5= ',' ( (lv_userAttributes_6_0= ruleAttributesMapEntry ) ) )* )? otherlv_7= ')' )? (otherlv_8= 'repeat' ( (lv_iteratorName_9_0= ruleIDString ) )? otherlv_10= ':' ( ( ( ( ruleNumberRepeats ) )=> (lv_repeats_11_0= ruleNumberRepeats ) ) | (otherlv_12= '[' ( (lv_repeats_13_0= ruleRange ) ) (otherlv_14= ',' ( (lv_repeats_15_0= ruleRange ) ) )* otherlv_16= ']' ) ) )? otherlv_17= '{' (otherlv_18= 'yield' otherlv_19= ':' ( (lv_yield_20_0= RULE_INT ) ) )? ( (lv_resourceYield_21_0= ruleResourceYieldMapEntry ) )* (otherlv_22= 'offset' otherlv_23= ':' ( (lv_offset_24_0= ruleEBigDecimal ) ) )? ( (lv_dispatches_25_0= ruleDispatch ) )* otherlv_26= '}' ) ;
    public final EObject ruleDispatchGroup() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_3=null;
        Token otherlv_5=null;
        Token otherlv_7=null;
        Token otherlv_8=null;
        Token otherlv_10=null;
        Token otherlv_12=null;
        Token otherlv_14=null;
        Token otherlv_16=null;
        Token otherlv_17=null;
        Token otherlv_18=null;
        Token otherlv_19=null;
        Token lv_yield_20_0=null;
        Token otherlv_22=null;
        Token otherlv_23=null;
        Token otherlv_26=null;
        AntlrDatatypeRuleToken lv_name_2_0 = null;

        EObject lv_userAttributes_4_0 = null;

        EObject lv_userAttributes_6_0 = null;

        AntlrDatatypeRuleToken lv_iteratorName_9_0 = null;

        EObject lv_repeats_11_0 = null;

        EObject lv_repeats_13_0 = null;

        EObject lv_repeats_15_0 = null;

        EObject lv_resourceYield_21_0 = null;

        AntlrDatatypeRuleToken lv_offset_24_0 = null;

        EObject lv_dispatches_25_0 = null;



        	enterRule();

        try {
            // InternalDispatching.g:275:2: ( ( () otherlv_1= 'activities' ( (lv_name_2_0= ruleIDString ) )? (otherlv_3= '(' ( ( (lv_userAttributes_4_0= ruleAttributesMapEntry ) ) (otherlv_5= ',' ( (lv_userAttributes_6_0= ruleAttributesMapEntry ) ) )* )? otherlv_7= ')' )? (otherlv_8= 'repeat' ( (lv_iteratorName_9_0= ruleIDString ) )? otherlv_10= ':' ( ( ( ( ruleNumberRepeats ) )=> (lv_repeats_11_0= ruleNumberRepeats ) ) | (otherlv_12= '[' ( (lv_repeats_13_0= ruleRange ) ) (otherlv_14= ',' ( (lv_repeats_15_0= ruleRange ) ) )* otherlv_16= ']' ) ) )? otherlv_17= '{' (otherlv_18= 'yield' otherlv_19= ':' ( (lv_yield_20_0= RULE_INT ) ) )? ( (lv_resourceYield_21_0= ruleResourceYieldMapEntry ) )* (otherlv_22= 'offset' otherlv_23= ':' ( (lv_offset_24_0= ruleEBigDecimal ) ) )? ( (lv_dispatches_25_0= ruleDispatch ) )* otherlv_26= '}' ) )
            // InternalDispatching.g:276:2: ( () otherlv_1= 'activities' ( (lv_name_2_0= ruleIDString ) )? (otherlv_3= '(' ( ( (lv_userAttributes_4_0= ruleAttributesMapEntry ) ) (otherlv_5= ',' ( (lv_userAttributes_6_0= ruleAttributesMapEntry ) ) )* )? otherlv_7= ')' )? (otherlv_8= 'repeat' ( (lv_iteratorName_9_0= ruleIDString ) )? otherlv_10= ':' ( ( ( ( ruleNumberRepeats ) )=> (lv_repeats_11_0= ruleNumberRepeats ) ) | (otherlv_12= '[' ( (lv_repeats_13_0= ruleRange ) ) (otherlv_14= ',' ( (lv_repeats_15_0= ruleRange ) ) )* otherlv_16= ']' ) ) )? otherlv_17= '{' (otherlv_18= 'yield' otherlv_19= ':' ( (lv_yield_20_0= RULE_INT ) ) )? ( (lv_resourceYield_21_0= ruleResourceYieldMapEntry ) )* (otherlv_22= 'offset' otherlv_23= ':' ( (lv_offset_24_0= ruleEBigDecimal ) ) )? ( (lv_dispatches_25_0= ruleDispatch ) )* otherlv_26= '}' )
            {
            // InternalDispatching.g:276:2: ( () otherlv_1= 'activities' ( (lv_name_2_0= ruleIDString ) )? (otherlv_3= '(' ( ( (lv_userAttributes_4_0= ruleAttributesMapEntry ) ) (otherlv_5= ',' ( (lv_userAttributes_6_0= ruleAttributesMapEntry ) ) )* )? otherlv_7= ')' )? (otherlv_8= 'repeat' ( (lv_iteratorName_9_0= ruleIDString ) )? otherlv_10= ':' ( ( ( ( ruleNumberRepeats ) )=> (lv_repeats_11_0= ruleNumberRepeats ) ) | (otherlv_12= '[' ( (lv_repeats_13_0= ruleRange ) ) (otherlv_14= ',' ( (lv_repeats_15_0= ruleRange ) ) )* otherlv_16= ']' ) ) )? otherlv_17= '{' (otherlv_18= 'yield' otherlv_19= ':' ( (lv_yield_20_0= RULE_INT ) ) )? ( (lv_resourceYield_21_0= ruleResourceYieldMapEntry ) )* (otherlv_22= 'offset' otherlv_23= ':' ( (lv_offset_24_0= ruleEBigDecimal ) ) )? ( (lv_dispatches_25_0= ruleDispatch ) )* otherlv_26= '}' )
            // InternalDispatching.g:277:3: () otherlv_1= 'activities' ( (lv_name_2_0= ruleIDString ) )? (otherlv_3= '(' ( ( (lv_userAttributes_4_0= ruleAttributesMapEntry ) ) (otherlv_5= ',' ( (lv_userAttributes_6_0= ruleAttributesMapEntry ) ) )* )? otherlv_7= ')' )? (otherlv_8= 'repeat' ( (lv_iteratorName_9_0= ruleIDString ) )? otherlv_10= ':' ( ( ( ( ruleNumberRepeats ) )=> (lv_repeats_11_0= ruleNumberRepeats ) ) | (otherlv_12= '[' ( (lv_repeats_13_0= ruleRange ) ) (otherlv_14= ',' ( (lv_repeats_15_0= ruleRange ) ) )* otherlv_16= ']' ) ) )? otherlv_17= '{' (otherlv_18= 'yield' otherlv_19= ':' ( (lv_yield_20_0= RULE_INT ) ) )? ( (lv_resourceYield_21_0= ruleResourceYieldMapEntry ) )* (otherlv_22= 'offset' otherlv_23= ':' ( (lv_offset_24_0= ruleEBigDecimal ) ) )? ( (lv_dispatches_25_0= ruleDispatch ) )* otherlv_26= '}'
            {
            // InternalDispatching.g:277:3: ()
            // InternalDispatching.g:278:4: 
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getDispatchGroupAccess().getDispatchGroupAction_0(),
              					current);
              			
            }

            }

            otherlv_1=(Token)match(input,17,FOLLOW_11); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_1, grammarAccess.getDispatchGroupAccess().getActivitiesKeyword_1());
              		
            }
            // InternalDispatching.g:288:3: ( (lv_name_2_0= ruleIDString ) )?
            int alt6=2;
            int LA6_0 = input.LA(1);

            if ( ((LA6_0>=RULE_ID && LA6_0<=RULE_STRING)) ) {
                alt6=1;
            }
            switch (alt6) {
                case 1 :
                    // InternalDispatching.g:289:4: (lv_name_2_0= ruleIDString )
                    {
                    // InternalDispatching.g:289:4: (lv_name_2_0= ruleIDString )
                    // InternalDispatching.g:290:5: lv_name_2_0= ruleIDString
                    {
                    if ( state.backtracking==0 ) {

                      					newCompositeNode(grammarAccess.getDispatchGroupAccess().getNameIDStringParserRuleCall_2_0());
                      				
                    }
                    pushFollow(FOLLOW_12);
                    lv_name_2_0=ruleIDString();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					if (current==null) {
                      						current = createModelElementForParent(grammarAccess.getDispatchGroupRule());
                      					}
                      					set(
                      						current,
                      						"name",
                      						lv_name_2_0,
                      						"org.eclipse.lsat.dispatching.teditor.Dispatching.IDString");
                      					afterParserOrEnumRuleCall();
                      				
                    }

                    }


                    }
                    break;

            }

            // InternalDispatching.g:307:3: (otherlv_3= '(' ( ( (lv_userAttributes_4_0= ruleAttributesMapEntry ) ) (otherlv_5= ',' ( (lv_userAttributes_6_0= ruleAttributesMapEntry ) ) )* )? otherlv_7= ')' )?
            int alt9=2;
            int LA9_0 = input.LA(1);

            if ( (LA9_0==18) ) {
                alt9=1;
            }
            switch (alt9) {
                case 1 :
                    // InternalDispatching.g:308:4: otherlv_3= '(' ( ( (lv_userAttributes_4_0= ruleAttributesMapEntry ) ) (otherlv_5= ',' ( (lv_userAttributes_6_0= ruleAttributesMapEntry ) ) )* )? otherlv_7= ')'
                    {
                    otherlv_3=(Token)match(input,18,FOLLOW_13); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_3, grammarAccess.getDispatchGroupAccess().getLeftParenthesisKeyword_3_0());
                      			
                    }
                    // InternalDispatching.g:312:4: ( ( (lv_userAttributes_4_0= ruleAttributesMapEntry ) ) (otherlv_5= ',' ( (lv_userAttributes_6_0= ruleAttributesMapEntry ) ) )* )?
                    int alt8=2;
                    int LA8_0 = input.LA(1);

                    if ( (LA8_0==RULE_ID) ) {
                        alt8=1;
                    }
                    switch (alt8) {
                        case 1 :
                            // InternalDispatching.g:313:5: ( (lv_userAttributes_4_0= ruleAttributesMapEntry ) ) (otherlv_5= ',' ( (lv_userAttributes_6_0= ruleAttributesMapEntry ) ) )*
                            {
                            // InternalDispatching.g:313:5: ( (lv_userAttributes_4_0= ruleAttributesMapEntry ) )
                            // InternalDispatching.g:314:6: (lv_userAttributes_4_0= ruleAttributesMapEntry )
                            {
                            // InternalDispatching.g:314:6: (lv_userAttributes_4_0= ruleAttributesMapEntry )
                            // InternalDispatching.g:315:7: lv_userAttributes_4_0= ruleAttributesMapEntry
                            {
                            if ( state.backtracking==0 ) {

                              							newCompositeNode(grammarAccess.getDispatchGroupAccess().getUserAttributesAttributesMapEntryParserRuleCall_3_1_0_0());
                              						
                            }
                            pushFollow(FOLLOW_14);
                            lv_userAttributes_4_0=ruleAttributesMapEntry();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              							if (current==null) {
                              								current = createModelElementForParent(grammarAccess.getDispatchGroupRule());
                              							}
                              							add(
                              								current,
                              								"userAttributes",
                              								lv_userAttributes_4_0,
                              								"org.eclipse.lsat.dispatching.teditor.Dispatching.AttributesMapEntry");
                              							afterParserOrEnumRuleCall();
                              						
                            }

                            }


                            }

                            // InternalDispatching.g:332:5: (otherlv_5= ',' ( (lv_userAttributes_6_0= ruleAttributesMapEntry ) ) )*
                            loop7:
                            do {
                                int alt7=2;
                                int LA7_0 = input.LA(1);

                                if ( (LA7_0==19) ) {
                                    alt7=1;
                                }


                                switch (alt7) {
                            	case 1 :
                            	    // InternalDispatching.g:333:6: otherlv_5= ',' ( (lv_userAttributes_6_0= ruleAttributesMapEntry ) )
                            	    {
                            	    otherlv_5=(Token)match(input,19,FOLLOW_15); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      						newLeafNode(otherlv_5, grammarAccess.getDispatchGroupAccess().getCommaKeyword_3_1_1_0());
                            	      					
                            	    }
                            	    // InternalDispatching.g:337:6: ( (lv_userAttributes_6_0= ruleAttributesMapEntry ) )
                            	    // InternalDispatching.g:338:7: (lv_userAttributes_6_0= ruleAttributesMapEntry )
                            	    {
                            	    // InternalDispatching.g:338:7: (lv_userAttributes_6_0= ruleAttributesMapEntry )
                            	    // InternalDispatching.g:339:8: lv_userAttributes_6_0= ruleAttributesMapEntry
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      								newCompositeNode(grammarAccess.getDispatchGroupAccess().getUserAttributesAttributesMapEntryParserRuleCall_3_1_1_1_0());
                            	      							
                            	    }
                            	    pushFollow(FOLLOW_14);
                            	    lv_userAttributes_6_0=ruleAttributesMapEntry();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      								if (current==null) {
                            	      									current = createModelElementForParent(grammarAccess.getDispatchGroupRule());
                            	      								}
                            	      								add(
                            	      									current,
                            	      									"userAttributes",
                            	      									lv_userAttributes_6_0,
                            	      									"org.eclipse.lsat.dispatching.teditor.Dispatching.AttributesMapEntry");
                            	      								afterParserOrEnumRuleCall();
                            	      							
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop7;
                                }
                            } while (true);


                            }
                            break;

                    }

                    otherlv_7=(Token)match(input,20,FOLLOW_16); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_7, grammarAccess.getDispatchGroupAccess().getRightParenthesisKeyword_3_2());
                      			
                    }

                    }
                    break;

            }

            // InternalDispatching.g:363:3: (otherlv_8= 'repeat' ( (lv_iteratorName_9_0= ruleIDString ) )? otherlv_10= ':' ( ( ( ( ruleNumberRepeats ) )=> (lv_repeats_11_0= ruleNumberRepeats ) ) | (otherlv_12= '[' ( (lv_repeats_13_0= ruleRange ) ) (otherlv_14= ',' ( (lv_repeats_15_0= ruleRange ) ) )* otherlv_16= ']' ) ) )?
            int alt13=2;
            int LA13_0 = input.LA(1);

            if ( (LA13_0==21) ) {
                alt13=1;
            }
            switch (alt13) {
                case 1 :
                    // InternalDispatching.g:364:4: otherlv_8= 'repeat' ( (lv_iteratorName_9_0= ruleIDString ) )? otherlv_10= ':' ( ( ( ( ruleNumberRepeats ) )=> (lv_repeats_11_0= ruleNumberRepeats ) ) | (otherlv_12= '[' ( (lv_repeats_13_0= ruleRange ) ) (otherlv_14= ',' ( (lv_repeats_15_0= ruleRange ) ) )* otherlv_16= ']' ) )
                    {
                    otherlv_8=(Token)match(input,21,FOLLOW_17); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_8, grammarAccess.getDispatchGroupAccess().getRepeatKeyword_4_0());
                      			
                    }
                    // InternalDispatching.g:368:4: ( (lv_iteratorName_9_0= ruleIDString ) )?
                    int alt10=2;
                    int LA10_0 = input.LA(1);

                    if ( ((LA10_0>=RULE_ID && LA10_0<=RULE_STRING)) ) {
                        alt10=1;
                    }
                    switch (alt10) {
                        case 1 :
                            // InternalDispatching.g:369:5: (lv_iteratorName_9_0= ruleIDString )
                            {
                            // InternalDispatching.g:369:5: (lv_iteratorName_9_0= ruleIDString )
                            // InternalDispatching.g:370:6: lv_iteratorName_9_0= ruleIDString
                            {
                            if ( state.backtracking==0 ) {

                              						newCompositeNode(grammarAccess.getDispatchGroupAccess().getIteratorNameIDStringParserRuleCall_4_1_0());
                              					
                            }
                            pushFollow(FOLLOW_6);
                            lv_iteratorName_9_0=ruleIDString();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						if (current==null) {
                              							current = createModelElementForParent(grammarAccess.getDispatchGroupRule());
                              						}
                              						set(
                              							current,
                              							"iteratorName",
                              							lv_iteratorName_9_0,
                              							"org.eclipse.lsat.dispatching.teditor.Dispatching.IDString");
                              						afterParserOrEnumRuleCall();
                              					
                            }

                            }


                            }
                            break;

                    }

                    otherlv_10=(Token)match(input,14,FOLLOW_18); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_10, grammarAccess.getDispatchGroupAccess().getColonKeyword_4_2());
                      			
                    }
                    // InternalDispatching.g:391:4: ( ( ( ( ruleNumberRepeats ) )=> (lv_repeats_11_0= ruleNumberRepeats ) ) | (otherlv_12= '[' ( (lv_repeats_13_0= ruleRange ) ) (otherlv_14= ',' ( (lv_repeats_15_0= ruleRange ) ) )* otherlv_16= ']' ) )
                    int alt12=2;
                    int LA12_0 = input.LA(1);

                    if ( (LA12_0==RULE_INT) && (synpred1_InternalDispatching())) {
                        alt12=1;
                    }
                    else if ( (LA12_0==22) ) {
                        alt12=2;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return current;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 12, 0, input);

                        throw nvae;
                    }
                    switch (alt12) {
                        case 1 :
                            // InternalDispatching.g:392:5: ( ( ( ruleNumberRepeats ) )=> (lv_repeats_11_0= ruleNumberRepeats ) )
                            {
                            // InternalDispatching.g:392:5: ( ( ( ruleNumberRepeats ) )=> (lv_repeats_11_0= ruleNumberRepeats ) )
                            // InternalDispatching.g:393:6: ( ( ruleNumberRepeats ) )=> (lv_repeats_11_0= ruleNumberRepeats )
                            {
                            // InternalDispatching.g:397:6: (lv_repeats_11_0= ruleNumberRepeats )
                            // InternalDispatching.g:398:7: lv_repeats_11_0= ruleNumberRepeats
                            {
                            if ( state.backtracking==0 ) {

                              							newCompositeNode(grammarAccess.getDispatchGroupAccess().getRepeatsNumberRepeatsParserRuleCall_4_3_0_0());
                              						
                            }
                            pushFollow(FOLLOW_4);
                            lv_repeats_11_0=ruleNumberRepeats();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              							if (current==null) {
                              								current = createModelElementForParent(grammarAccess.getDispatchGroupRule());
                              							}
                              							add(
                              								current,
                              								"repeats",
                              								lv_repeats_11_0,
                              								"org.eclipse.lsat.dispatching.teditor.Dispatching.NumberRepeats");
                              							afterParserOrEnumRuleCall();
                              						
                            }

                            }


                            }


                            }
                            break;
                        case 2 :
                            // InternalDispatching.g:416:5: (otherlv_12= '[' ( (lv_repeats_13_0= ruleRange ) ) (otherlv_14= ',' ( (lv_repeats_15_0= ruleRange ) ) )* otherlv_16= ']' )
                            {
                            // InternalDispatching.g:416:5: (otherlv_12= '[' ( (lv_repeats_13_0= ruleRange ) ) (otherlv_14= ',' ( (lv_repeats_15_0= ruleRange ) ) )* otherlv_16= ']' )
                            // InternalDispatching.g:417:6: otherlv_12= '[' ( (lv_repeats_13_0= ruleRange ) ) (otherlv_14= ',' ( (lv_repeats_15_0= ruleRange ) ) )* otherlv_16= ']'
                            {
                            otherlv_12=(Token)match(input,22,FOLLOW_7); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_12, grammarAccess.getDispatchGroupAccess().getLeftSquareBracketKeyword_4_3_1_0());
                              					
                            }
                            // InternalDispatching.g:421:6: ( (lv_repeats_13_0= ruleRange ) )
                            // InternalDispatching.g:422:7: (lv_repeats_13_0= ruleRange )
                            {
                            // InternalDispatching.g:422:7: (lv_repeats_13_0= ruleRange )
                            // InternalDispatching.g:423:8: lv_repeats_13_0= ruleRange
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getDispatchGroupAccess().getRepeatsRangeParserRuleCall_4_3_1_1_0());
                              							
                            }
                            pushFollow(FOLLOW_19);
                            lv_repeats_13_0=ruleRange();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getDispatchGroupRule());
                              								}
                              								add(
                              									current,
                              									"repeats",
                              									lv_repeats_13_0,
                              									"org.eclipse.lsat.dispatching.teditor.Dispatching.Range");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }

                            // InternalDispatching.g:440:6: (otherlv_14= ',' ( (lv_repeats_15_0= ruleRange ) ) )*
                            loop11:
                            do {
                                int alt11=2;
                                int LA11_0 = input.LA(1);

                                if ( (LA11_0==19) ) {
                                    alt11=1;
                                }


                                switch (alt11) {
                            	case 1 :
                            	    // InternalDispatching.g:441:7: otherlv_14= ',' ( (lv_repeats_15_0= ruleRange ) )
                            	    {
                            	    otherlv_14=(Token)match(input,19,FOLLOW_7); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      							newLeafNode(otherlv_14, grammarAccess.getDispatchGroupAccess().getCommaKeyword_4_3_1_2_0());
                            	      						
                            	    }
                            	    // InternalDispatching.g:445:7: ( (lv_repeats_15_0= ruleRange ) )
                            	    // InternalDispatching.g:446:8: (lv_repeats_15_0= ruleRange )
                            	    {
                            	    // InternalDispatching.g:446:8: (lv_repeats_15_0= ruleRange )
                            	    // InternalDispatching.g:447:9: lv_repeats_15_0= ruleRange
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      									newCompositeNode(grammarAccess.getDispatchGroupAccess().getRepeatsRangeParserRuleCall_4_3_1_2_1_0());
                            	      								
                            	    }
                            	    pushFollow(FOLLOW_19);
                            	    lv_repeats_15_0=ruleRange();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      									if (current==null) {
                            	      										current = createModelElementForParent(grammarAccess.getDispatchGroupRule());
                            	      									}
                            	      									add(
                            	      										current,
                            	      										"repeats",
                            	      										lv_repeats_15_0,
                            	      										"org.eclipse.lsat.dispatching.teditor.Dispatching.Range");
                            	      									afterParserOrEnumRuleCall();
                            	      								
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop11;
                                }
                            } while (true);

                            otherlv_16=(Token)match(input,23,FOLLOW_4); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_16, grammarAccess.getDispatchGroupAccess().getRightSquareBracketKeyword_4_3_1_3());
                              					
                            }

                            }


                            }
                            break;

                    }


                    }
                    break;

            }

            otherlv_17=(Token)match(input,12,FOLLOW_20); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_17, grammarAccess.getDispatchGroupAccess().getLeftCurlyBracketKeyword_5());
              		
            }
            // InternalDispatching.g:476:3: (otherlv_18= 'yield' otherlv_19= ':' ( (lv_yield_20_0= RULE_INT ) ) )?
            int alt14=2;
            int LA14_0 = input.LA(1);

            if ( (LA14_0==24) ) {
                int LA14_1 = input.LA(2);

                if ( (LA14_1==14) ) {
                    alt14=1;
                }
            }
            switch (alt14) {
                case 1 :
                    // InternalDispatching.g:477:4: otherlv_18= 'yield' otherlv_19= ':' ( (lv_yield_20_0= RULE_INT ) )
                    {
                    otherlv_18=(Token)match(input,24,FOLLOW_6); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_18, grammarAccess.getDispatchGroupAccess().getYieldKeyword_6_0());
                      			
                    }
                    otherlv_19=(Token)match(input,14,FOLLOW_7); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_19, grammarAccess.getDispatchGroupAccess().getColonKeyword_6_1());
                      			
                    }
                    // InternalDispatching.g:485:4: ( (lv_yield_20_0= RULE_INT ) )
                    // InternalDispatching.g:486:5: (lv_yield_20_0= RULE_INT )
                    {
                    // InternalDispatching.g:486:5: (lv_yield_20_0= RULE_INT )
                    // InternalDispatching.g:487:6: lv_yield_20_0= RULE_INT
                    {
                    lv_yield_20_0=(Token)match(input,RULE_INT,FOLLOW_20); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						newLeafNode(lv_yield_20_0, grammarAccess.getDispatchGroupAccess().getYieldINTTerminalRuleCall_6_2_0());
                      					
                    }
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElement(grammarAccess.getDispatchGroupRule());
                      						}
                      						setWithLastConsumed(
                      							current,
                      							"yield",
                      							lv_yield_20_0,
                      							"org.eclipse.xtext.common.Terminals.INT");
                      					
                    }

                    }


                    }


                    }
                    break;

            }

            // InternalDispatching.g:504:3: ( (lv_resourceYield_21_0= ruleResourceYieldMapEntry ) )*
            loop15:
            do {
                int alt15=2;
                int LA15_0 = input.LA(1);

                if ( (LA15_0==24) ) {
                    alt15=1;
                }


                switch (alt15) {
            	case 1 :
            	    // InternalDispatching.g:505:4: (lv_resourceYield_21_0= ruleResourceYieldMapEntry )
            	    {
            	    // InternalDispatching.g:505:4: (lv_resourceYield_21_0= ruleResourceYieldMapEntry )
            	    // InternalDispatching.g:506:5: lv_resourceYield_21_0= ruleResourceYieldMapEntry
            	    {
            	    if ( state.backtracking==0 ) {

            	      					newCompositeNode(grammarAccess.getDispatchGroupAccess().getResourceYieldResourceYieldMapEntryParserRuleCall_7_0());
            	      				
            	    }
            	    pushFollow(FOLLOW_20);
            	    lv_resourceYield_21_0=ruleResourceYieldMapEntry();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      					if (current==null) {
            	      						current = createModelElementForParent(grammarAccess.getDispatchGroupRule());
            	      					}
            	      					add(
            	      						current,
            	      						"resourceYield",
            	      						lv_resourceYield_21_0,
            	      						"org.eclipse.lsat.dispatching.teditor.Dispatching.ResourceYieldMapEntry");
            	      					afterParserOrEnumRuleCall();
            	      				
            	    }

            	    }


            	    }
            	    break;

            	default :
            	    break loop15;
                }
            } while (true);

            // InternalDispatching.g:523:3: (otherlv_22= 'offset' otherlv_23= ':' ( (lv_offset_24_0= ruleEBigDecimal ) ) )?
            int alt16=2;
            int LA16_0 = input.LA(1);

            if ( (LA16_0==25) ) {
                alt16=1;
            }
            switch (alt16) {
                case 1 :
                    // InternalDispatching.g:524:4: otherlv_22= 'offset' otherlv_23= ':' ( (lv_offset_24_0= ruleEBigDecimal ) )
                    {
                    otherlv_22=(Token)match(input,25,FOLLOW_6); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_22, grammarAccess.getDispatchGroupAccess().getOffsetKeyword_8_0());
                      			
                    }
                    otherlv_23=(Token)match(input,14,FOLLOW_21); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_23, grammarAccess.getDispatchGroupAccess().getColonKeyword_8_1());
                      			
                    }
                    // InternalDispatching.g:532:4: ( (lv_offset_24_0= ruleEBigDecimal ) )
                    // InternalDispatching.g:533:5: (lv_offset_24_0= ruleEBigDecimal )
                    {
                    // InternalDispatching.g:533:5: (lv_offset_24_0= ruleEBigDecimal )
                    // InternalDispatching.g:534:6: lv_offset_24_0= ruleEBigDecimal
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getDispatchGroupAccess().getOffsetEBigDecimalParserRuleCall_8_2_0());
                      					
                    }
                    pushFollow(FOLLOW_22);
                    lv_offset_24_0=ruleEBigDecimal();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getDispatchGroupRule());
                      						}
                      						set(
                      							current,
                      							"offset",
                      							lv_offset_24_0,
                      							"org.eclipse.lsat.dispatching.teditor.Dispatching.EBigDecimal");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }


                    }
                    break;

            }

            // InternalDispatching.g:552:3: ( (lv_dispatches_25_0= ruleDispatch ) )*
            loop17:
            do {
                int alt17=2;
                int LA17_0 = input.LA(1);

                if ( (LA17_0==RULE_ID) ) {
                    alt17=1;
                }


                switch (alt17) {
            	case 1 :
            	    // InternalDispatching.g:553:4: (lv_dispatches_25_0= ruleDispatch )
            	    {
            	    // InternalDispatching.g:553:4: (lv_dispatches_25_0= ruleDispatch )
            	    // InternalDispatching.g:554:5: lv_dispatches_25_0= ruleDispatch
            	    {
            	    if ( state.backtracking==0 ) {

            	      					newCompositeNode(grammarAccess.getDispatchGroupAccess().getDispatchesDispatchParserRuleCall_9_0());
            	      				
            	    }
            	    pushFollow(FOLLOW_22);
            	    lv_dispatches_25_0=ruleDispatch();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      					if (current==null) {
            	      						current = createModelElementForParent(grammarAccess.getDispatchGroupRule());
            	      					}
            	      					add(
            	      						current,
            	      						"dispatches",
            	      						lv_dispatches_25_0,
            	      						"org.eclipse.lsat.dispatching.teditor.Dispatching.Dispatch");
            	      					afterParserOrEnumRuleCall();
            	      				
            	    }

            	    }


            	    }
            	    break;

            	default :
            	    break loop17;
                }
            } while (true);

            otherlv_26=(Token)match(input,15,FOLLOW_2); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_26, grammarAccess.getDispatchGroupAccess().getRightCurlyBracketKeyword_10());
              		
            }

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleDispatchGroup"


    // $ANTLR start "entryRuleNumberRepeats"
    // InternalDispatching.g:579:1: entryRuleNumberRepeats returns [EObject current=null] : iv_ruleNumberRepeats= ruleNumberRepeats EOF ;
    public final EObject entryRuleNumberRepeats() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleNumberRepeats = null;


        try {
            // InternalDispatching.g:579:54: (iv_ruleNumberRepeats= ruleNumberRepeats EOF )
            // InternalDispatching.g:580:2: iv_ruleNumberRepeats= ruleNumberRepeats EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getNumberRepeatsRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleNumberRepeats=ruleNumberRepeats();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleNumberRepeats; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleNumberRepeats"


    // $ANTLR start "ruleNumberRepeats"
    // InternalDispatching.g:586:1: ruleNumberRepeats returns [EObject current=null] : ( () ( (lv_numRepeats_1_0= RULE_INT ) ) ) ;
    public final EObject ruleNumberRepeats() throws RecognitionException {
        EObject current = null;

        Token lv_numRepeats_1_0=null;


        	enterRule();

        try {
            // InternalDispatching.g:592:2: ( ( () ( (lv_numRepeats_1_0= RULE_INT ) ) ) )
            // InternalDispatching.g:593:2: ( () ( (lv_numRepeats_1_0= RULE_INT ) ) )
            {
            // InternalDispatching.g:593:2: ( () ( (lv_numRepeats_1_0= RULE_INT ) ) )
            // InternalDispatching.g:594:3: () ( (lv_numRepeats_1_0= RULE_INT ) )
            {
            // InternalDispatching.g:594:3: ()
            // InternalDispatching.g:595:4: 
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getNumberRepeatsAccess().getRepeatAction_0(),
              					current);
              			
            }

            }

            // InternalDispatching.g:601:3: ( (lv_numRepeats_1_0= RULE_INT ) )
            // InternalDispatching.g:602:4: (lv_numRepeats_1_0= RULE_INT )
            {
            // InternalDispatching.g:602:4: (lv_numRepeats_1_0= RULE_INT )
            // InternalDispatching.g:603:5: lv_numRepeats_1_0= RULE_INT
            {
            lv_numRepeats_1_0=(Token)match(input,RULE_INT,FOLLOW_2); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					newLeafNode(lv_numRepeats_1_0, grammarAccess.getNumberRepeatsAccess().getNumRepeatsINTTerminalRuleCall_1_0());
              				
            }
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElement(grammarAccess.getNumberRepeatsRule());
              					}
              					setWithLastConsumed(
              						current,
              						"numRepeats",
              						lv_numRepeats_1_0,
              						"org.eclipse.xtext.common.Terminals.INT");
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleNumberRepeats"


    // $ANTLR start "entryRuleRange"
    // InternalDispatching.g:623:1: entryRuleRange returns [EObject current=null] : iv_ruleRange= ruleRange EOF ;
    public final EObject entryRuleRange() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleRange = null;


        try {
            // InternalDispatching.g:623:46: (iv_ruleRange= ruleRange EOF )
            // InternalDispatching.g:624:2: iv_ruleRange= ruleRange EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getRangeRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleRange=ruleRange();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleRange; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleRange"


    // $ANTLR start "ruleRange"
    // InternalDispatching.g:630:1: ruleRange returns [EObject current=null] : ( () ( ( (lv_start_1_0= RULE_INT ) ) | ( ( (lv_start_2_0= RULE_INT ) ) otherlv_3= '..' ( (lv_end_4_0= RULE_INT ) ) ) ) ) ;
    public final EObject ruleRange() throws RecognitionException {
        EObject current = null;

        Token lv_start_1_0=null;
        Token lv_start_2_0=null;
        Token otherlv_3=null;
        Token lv_end_4_0=null;


        	enterRule();

        try {
            // InternalDispatching.g:636:2: ( ( () ( ( (lv_start_1_0= RULE_INT ) ) | ( ( (lv_start_2_0= RULE_INT ) ) otherlv_3= '..' ( (lv_end_4_0= RULE_INT ) ) ) ) ) )
            // InternalDispatching.g:637:2: ( () ( ( (lv_start_1_0= RULE_INT ) ) | ( ( (lv_start_2_0= RULE_INT ) ) otherlv_3= '..' ( (lv_end_4_0= RULE_INT ) ) ) ) )
            {
            // InternalDispatching.g:637:2: ( () ( ( (lv_start_1_0= RULE_INT ) ) | ( ( (lv_start_2_0= RULE_INT ) ) otherlv_3= '..' ( (lv_end_4_0= RULE_INT ) ) ) ) )
            // InternalDispatching.g:638:3: () ( ( (lv_start_1_0= RULE_INT ) ) | ( ( (lv_start_2_0= RULE_INT ) ) otherlv_3= '..' ( (lv_end_4_0= RULE_INT ) ) ) )
            {
            // InternalDispatching.g:638:3: ()
            // InternalDispatching.g:639:4: 
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getRangeAccess().getRepeatAction_0(),
              					current);
              			
            }

            }

            // InternalDispatching.g:645:3: ( ( (lv_start_1_0= RULE_INT ) ) | ( ( (lv_start_2_0= RULE_INT ) ) otherlv_3= '..' ( (lv_end_4_0= RULE_INT ) ) ) )
            int alt18=2;
            int LA18_0 = input.LA(1);

            if ( (LA18_0==RULE_INT) ) {
                int LA18_1 = input.LA(2);

                if ( (LA18_1==EOF||LA18_1==19||LA18_1==23) ) {
                    alt18=1;
                }
                else if ( (LA18_1==26) ) {
                    alt18=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return current;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 18, 1, input);

                    throw nvae;
                }
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 18, 0, input);

                throw nvae;
            }
            switch (alt18) {
                case 1 :
                    // InternalDispatching.g:646:4: ( (lv_start_1_0= RULE_INT ) )
                    {
                    // InternalDispatching.g:646:4: ( (lv_start_1_0= RULE_INT ) )
                    // InternalDispatching.g:647:5: (lv_start_1_0= RULE_INT )
                    {
                    // InternalDispatching.g:647:5: (lv_start_1_0= RULE_INT )
                    // InternalDispatching.g:648:6: lv_start_1_0= RULE_INT
                    {
                    lv_start_1_0=(Token)match(input,RULE_INT,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						newLeafNode(lv_start_1_0, grammarAccess.getRangeAccess().getStartINTTerminalRuleCall_1_0_0());
                      					
                    }
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElement(grammarAccess.getRangeRule());
                      						}
                      						setWithLastConsumed(
                      							current,
                      							"start",
                      							lv_start_1_0,
                      							"org.eclipse.xtext.common.Terminals.INT");
                      					
                    }

                    }


                    }


                    }
                    break;
                case 2 :
                    // InternalDispatching.g:665:4: ( ( (lv_start_2_0= RULE_INT ) ) otherlv_3= '..' ( (lv_end_4_0= RULE_INT ) ) )
                    {
                    // InternalDispatching.g:665:4: ( ( (lv_start_2_0= RULE_INT ) ) otherlv_3= '..' ( (lv_end_4_0= RULE_INT ) ) )
                    // InternalDispatching.g:666:5: ( (lv_start_2_0= RULE_INT ) ) otherlv_3= '..' ( (lv_end_4_0= RULE_INT ) )
                    {
                    // InternalDispatching.g:666:5: ( (lv_start_2_0= RULE_INT ) )
                    // InternalDispatching.g:667:6: (lv_start_2_0= RULE_INT )
                    {
                    // InternalDispatching.g:667:6: (lv_start_2_0= RULE_INT )
                    // InternalDispatching.g:668:7: lv_start_2_0= RULE_INT
                    {
                    lv_start_2_0=(Token)match(input,RULE_INT,FOLLOW_23); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							newLeafNode(lv_start_2_0, grammarAccess.getRangeAccess().getStartINTTerminalRuleCall_1_1_0_0());
                      						
                    }
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElement(grammarAccess.getRangeRule());
                      							}
                      							setWithLastConsumed(
                      								current,
                      								"start",
                      								lv_start_2_0,
                      								"org.eclipse.xtext.common.Terminals.INT");
                      						
                    }

                    }


                    }

                    otherlv_3=(Token)match(input,26,FOLLOW_7); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_3, grammarAccess.getRangeAccess().getFullStopFullStopKeyword_1_1_1());
                      				
                    }
                    // InternalDispatching.g:688:5: ( (lv_end_4_0= RULE_INT ) )
                    // InternalDispatching.g:689:6: (lv_end_4_0= RULE_INT )
                    {
                    // InternalDispatching.g:689:6: (lv_end_4_0= RULE_INT )
                    // InternalDispatching.g:690:7: lv_end_4_0= RULE_INT
                    {
                    lv_end_4_0=(Token)match(input,RULE_INT,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							newLeafNode(lv_end_4_0, grammarAccess.getRangeAccess().getEndINTTerminalRuleCall_1_1_2_0());
                      						
                    }
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElement(grammarAccess.getRangeRule());
                      							}
                      							setWithLastConsumed(
                      								current,
                      								"end",
                      								lv_end_4_0,
                      								"org.eclipse.xtext.common.Terminals.INT");
                      						
                    }

                    }


                    }


                    }


                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleRange"


    // $ANTLR start "entryRuleResourceYieldMapEntry"
    // InternalDispatching.g:712:1: entryRuleResourceYieldMapEntry returns [EObject current=null] : iv_ruleResourceYieldMapEntry= ruleResourceYieldMapEntry EOF ;
    public final EObject entryRuleResourceYieldMapEntry() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleResourceYieldMapEntry = null;


        try {
            // InternalDispatching.g:712:62: (iv_ruleResourceYieldMapEntry= ruleResourceYieldMapEntry EOF )
            // InternalDispatching.g:713:2: iv_ruleResourceYieldMapEntry= ruleResourceYieldMapEntry EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getResourceYieldMapEntryRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleResourceYieldMapEntry=ruleResourceYieldMapEntry();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleResourceYieldMapEntry; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleResourceYieldMapEntry"


    // $ANTLR start "ruleResourceYieldMapEntry"
    // InternalDispatching.g:719:1: ruleResourceYieldMapEntry returns [EObject current=null] : (otherlv_0= 'yield' ( ( ruleResourceQualifiedName ) ) otherlv_2= ':' ( (lv_value_3_0= RULE_INT ) ) ) ;
    public final EObject ruleResourceYieldMapEntry() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_2=null;
        Token lv_value_3_0=null;


        	enterRule();

        try {
            // InternalDispatching.g:725:2: ( (otherlv_0= 'yield' ( ( ruleResourceQualifiedName ) ) otherlv_2= ':' ( (lv_value_3_0= RULE_INT ) ) ) )
            // InternalDispatching.g:726:2: (otherlv_0= 'yield' ( ( ruleResourceQualifiedName ) ) otherlv_2= ':' ( (lv_value_3_0= RULE_INT ) ) )
            {
            // InternalDispatching.g:726:2: (otherlv_0= 'yield' ( ( ruleResourceQualifiedName ) ) otherlv_2= ':' ( (lv_value_3_0= RULE_INT ) ) )
            // InternalDispatching.g:727:3: otherlv_0= 'yield' ( ( ruleResourceQualifiedName ) ) otherlv_2= ':' ( (lv_value_3_0= RULE_INT ) )
            {
            otherlv_0=(Token)match(input,24,FOLLOW_10); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_0, grammarAccess.getResourceYieldMapEntryAccess().getYieldKeyword_0());
              		
            }
            // InternalDispatching.g:731:3: ( ( ruleResourceQualifiedName ) )
            // InternalDispatching.g:732:4: ( ruleResourceQualifiedName )
            {
            // InternalDispatching.g:732:4: ( ruleResourceQualifiedName )
            // InternalDispatching.g:733:5: ruleResourceQualifiedName
            {
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElement(grammarAccess.getResourceYieldMapEntryRule());
              					}
              				
            }
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getResourceYieldMapEntryAccess().getKeyIResourceCrossReference_1_0());
              				
            }
            pushFollow(FOLLOW_6);
            ruleResourceQualifiedName();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            otherlv_2=(Token)match(input,14,FOLLOW_7); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_2, grammarAccess.getResourceYieldMapEntryAccess().getColonKeyword_2());
              		
            }
            // InternalDispatching.g:751:3: ( (lv_value_3_0= RULE_INT ) )
            // InternalDispatching.g:752:4: (lv_value_3_0= RULE_INT )
            {
            // InternalDispatching.g:752:4: (lv_value_3_0= RULE_INT )
            // InternalDispatching.g:753:5: lv_value_3_0= RULE_INT
            {
            lv_value_3_0=(Token)match(input,RULE_INT,FOLLOW_2); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					newLeafNode(lv_value_3_0, grammarAccess.getResourceYieldMapEntryAccess().getValueINTTerminalRuleCall_3_0());
              				
            }
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElement(grammarAccess.getResourceYieldMapEntryRule());
              					}
              					setWithLastConsumed(
              						current,
              						"value",
              						lv_value_3_0,
              						"org.eclipse.xtext.common.Terminals.INT");
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleResourceYieldMapEntry"


    // $ANTLR start "entryRuleAttribute"
    // InternalDispatching.g:773:1: entryRuleAttribute returns [EObject current=null] : iv_ruleAttribute= ruleAttribute EOF ;
    public final EObject entryRuleAttribute() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleAttribute = null;


        try {
            // InternalDispatching.g:773:50: (iv_ruleAttribute= ruleAttribute EOF )
            // InternalDispatching.g:774:2: iv_ruleAttribute= ruleAttribute EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getAttributeRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleAttribute=ruleAttribute();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleAttribute; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleAttribute"


    // $ANTLR start "ruleAttribute"
    // InternalDispatching.g:780:1: ruleAttribute returns [EObject current=null] : ( () ( (lv_name_1_0= RULE_ID ) ) ) ;
    public final EObject ruleAttribute() throws RecognitionException {
        EObject current = null;

        Token lv_name_1_0=null;


        	enterRule();

        try {
            // InternalDispatching.g:786:2: ( ( () ( (lv_name_1_0= RULE_ID ) ) ) )
            // InternalDispatching.g:787:2: ( () ( (lv_name_1_0= RULE_ID ) ) )
            {
            // InternalDispatching.g:787:2: ( () ( (lv_name_1_0= RULE_ID ) ) )
            // InternalDispatching.g:788:3: () ( (lv_name_1_0= RULE_ID ) )
            {
            // InternalDispatching.g:788:3: ()
            // InternalDispatching.g:789:4: 
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getAttributeAccess().getAttributeAction_0(),
              					current);
              			
            }

            }

            // InternalDispatching.g:795:3: ( (lv_name_1_0= RULE_ID ) )
            // InternalDispatching.g:796:4: (lv_name_1_0= RULE_ID )
            {
            // InternalDispatching.g:796:4: (lv_name_1_0= RULE_ID )
            // InternalDispatching.g:797:5: lv_name_1_0= RULE_ID
            {
            lv_name_1_0=(Token)match(input,RULE_ID,FOLLOW_2); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					newLeafNode(lv_name_1_0, grammarAccess.getAttributeAccess().getNameIDTerminalRuleCall_1_0());
              				
            }
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElement(grammarAccess.getAttributeRule());
              					}
              					setWithLastConsumed(
              						current,
              						"name",
              						lv_name_1_0,
              						"org.eclipse.xtext.common.Terminals.ID");
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleAttribute"


    // $ANTLR start "entryRuleDispatch"
    // InternalDispatching.g:817:1: entryRuleDispatch returns [EObject current=null] : iv_ruleDispatch= ruleDispatch EOF ;
    public final EObject entryRuleDispatch() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleDispatch = null;


        try {
            // InternalDispatching.g:817:49: (iv_ruleDispatch= ruleDispatch EOF )
            // InternalDispatching.g:818:2: iv_ruleDispatch= ruleDispatch EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getDispatchRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleDispatch=ruleDispatch();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleDispatch; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleDispatch"


    // $ANTLR start "ruleDispatch"
    // InternalDispatching.g:824:1: ruleDispatch returns [EObject current=null] : ( ( (otherlv_0= RULE_ID ) ) (otherlv_1= '[' ( ( ruleResourceItemQualifiedName ) ) (otherlv_3= ',' ( ( ruleResourceItemQualifiedName ) ) )* otherlv_5= ']' )? (otherlv_6= '(' ( (lv_description_7_0= RULE_STRING ) )? ( ( (lv_userAttributes_8_0= ruleAttributesMapEntry ) ) (otherlv_9= ',' ( (lv_userAttributes_10_0= ruleAttributesMapEntry ) ) )* )? otherlv_11= ')' )? ) ;
    public final EObject ruleDispatch() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_1=null;
        Token otherlv_3=null;
        Token otherlv_5=null;
        Token otherlv_6=null;
        Token lv_description_7_0=null;
        Token otherlv_9=null;
        Token otherlv_11=null;
        EObject lv_userAttributes_8_0 = null;

        EObject lv_userAttributes_10_0 = null;



        	enterRule();

        try {
            // InternalDispatching.g:830:2: ( ( ( (otherlv_0= RULE_ID ) ) (otherlv_1= '[' ( ( ruleResourceItemQualifiedName ) ) (otherlv_3= ',' ( ( ruleResourceItemQualifiedName ) ) )* otherlv_5= ']' )? (otherlv_6= '(' ( (lv_description_7_0= RULE_STRING ) )? ( ( (lv_userAttributes_8_0= ruleAttributesMapEntry ) ) (otherlv_9= ',' ( (lv_userAttributes_10_0= ruleAttributesMapEntry ) ) )* )? otherlv_11= ')' )? ) )
            // InternalDispatching.g:831:2: ( ( (otherlv_0= RULE_ID ) ) (otherlv_1= '[' ( ( ruleResourceItemQualifiedName ) ) (otherlv_3= ',' ( ( ruleResourceItemQualifiedName ) ) )* otherlv_5= ']' )? (otherlv_6= '(' ( (lv_description_7_0= RULE_STRING ) )? ( ( (lv_userAttributes_8_0= ruleAttributesMapEntry ) ) (otherlv_9= ',' ( (lv_userAttributes_10_0= ruleAttributesMapEntry ) ) )* )? otherlv_11= ')' )? )
            {
            // InternalDispatching.g:831:2: ( ( (otherlv_0= RULE_ID ) ) (otherlv_1= '[' ( ( ruleResourceItemQualifiedName ) ) (otherlv_3= ',' ( ( ruleResourceItemQualifiedName ) ) )* otherlv_5= ']' )? (otherlv_6= '(' ( (lv_description_7_0= RULE_STRING ) )? ( ( (lv_userAttributes_8_0= ruleAttributesMapEntry ) ) (otherlv_9= ',' ( (lv_userAttributes_10_0= ruleAttributesMapEntry ) ) )* )? otherlv_11= ')' )? )
            // InternalDispatching.g:832:3: ( (otherlv_0= RULE_ID ) ) (otherlv_1= '[' ( ( ruleResourceItemQualifiedName ) ) (otherlv_3= ',' ( ( ruleResourceItemQualifiedName ) ) )* otherlv_5= ']' )? (otherlv_6= '(' ( (lv_description_7_0= RULE_STRING ) )? ( ( (lv_userAttributes_8_0= ruleAttributesMapEntry ) ) (otherlv_9= ',' ( (lv_userAttributes_10_0= ruleAttributesMapEntry ) ) )* )? otherlv_11= ')' )?
            {
            // InternalDispatching.g:832:3: ( (otherlv_0= RULE_ID ) )
            // InternalDispatching.g:833:4: (otherlv_0= RULE_ID )
            {
            // InternalDispatching.g:833:4: (otherlv_0= RULE_ID )
            // InternalDispatching.g:834:5: otherlv_0= RULE_ID
            {
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElement(grammarAccess.getDispatchRule());
              					}
              				
            }
            otherlv_0=(Token)match(input,RULE_ID,FOLLOW_24); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					newLeafNode(otherlv_0, grammarAccess.getDispatchAccess().getActivityActivityCrossReference_0_0());
              				
            }

            }


            }

            // InternalDispatching.g:845:3: (otherlv_1= '[' ( ( ruleResourceItemQualifiedName ) ) (otherlv_3= ',' ( ( ruleResourceItemQualifiedName ) ) )* otherlv_5= ']' )?
            int alt20=2;
            int LA20_0 = input.LA(1);

            if ( (LA20_0==22) ) {
                alt20=1;
            }
            switch (alt20) {
                case 1 :
                    // InternalDispatching.g:846:4: otherlv_1= '[' ( ( ruleResourceItemQualifiedName ) ) (otherlv_3= ',' ( ( ruleResourceItemQualifiedName ) ) )* otherlv_5= ']'
                    {
                    otherlv_1=(Token)match(input,22,FOLLOW_10); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_1, grammarAccess.getDispatchAccess().getLeftSquareBracketKeyword_1_0());
                      			
                    }
                    // InternalDispatching.g:850:4: ( ( ruleResourceItemQualifiedName ) )
                    // InternalDispatching.g:851:5: ( ruleResourceItemQualifiedName )
                    {
                    // InternalDispatching.g:851:5: ( ruleResourceItemQualifiedName )
                    // InternalDispatching.g:852:6: ruleResourceItemQualifiedName
                    {
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElement(grammarAccess.getDispatchRule());
                      						}
                      					
                    }
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getDispatchAccess().getResourceItemsResourceItemCrossReference_1_1_0());
                      					
                    }
                    pushFollow(FOLLOW_19);
                    ruleResourceItemQualifiedName();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }

                    // InternalDispatching.g:866:4: (otherlv_3= ',' ( ( ruleResourceItemQualifiedName ) ) )*
                    loop19:
                    do {
                        int alt19=2;
                        int LA19_0 = input.LA(1);

                        if ( (LA19_0==19) ) {
                            alt19=1;
                        }


                        switch (alt19) {
                    	case 1 :
                    	    // InternalDispatching.g:867:5: otherlv_3= ',' ( ( ruleResourceItemQualifiedName ) )
                    	    {
                    	    otherlv_3=(Token)match(input,19,FOLLOW_10); if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      					newLeafNode(otherlv_3, grammarAccess.getDispatchAccess().getCommaKeyword_1_2_0());
                    	      				
                    	    }
                    	    // InternalDispatching.g:871:5: ( ( ruleResourceItemQualifiedName ) )
                    	    // InternalDispatching.g:872:6: ( ruleResourceItemQualifiedName )
                    	    {
                    	    // InternalDispatching.g:872:6: ( ruleResourceItemQualifiedName )
                    	    // InternalDispatching.g:873:7: ruleResourceItemQualifiedName
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElement(grammarAccess.getDispatchRule());
                    	      							}
                    	      						
                    	    }
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getDispatchAccess().getResourceItemsResourceItemCrossReference_1_2_1_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_19);
                    	    ruleResourceItemQualifiedName();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop19;
                        }
                    } while (true);

                    otherlv_5=(Token)match(input,23,FOLLOW_25); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_5, grammarAccess.getDispatchAccess().getRightSquareBracketKeyword_1_3());
                      			
                    }

                    }
                    break;

            }

            // InternalDispatching.g:893:3: (otherlv_6= '(' ( (lv_description_7_0= RULE_STRING ) )? ( ( (lv_userAttributes_8_0= ruleAttributesMapEntry ) ) (otherlv_9= ',' ( (lv_userAttributes_10_0= ruleAttributesMapEntry ) ) )* )? otherlv_11= ')' )?
            int alt24=2;
            int LA24_0 = input.LA(1);

            if ( (LA24_0==18) ) {
                alt24=1;
            }
            switch (alt24) {
                case 1 :
                    // InternalDispatching.g:894:4: otherlv_6= '(' ( (lv_description_7_0= RULE_STRING ) )? ( ( (lv_userAttributes_8_0= ruleAttributesMapEntry ) ) (otherlv_9= ',' ( (lv_userAttributes_10_0= ruleAttributesMapEntry ) ) )* )? otherlv_11= ')'
                    {
                    otherlv_6=(Token)match(input,18,FOLLOW_26); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_6, grammarAccess.getDispatchAccess().getLeftParenthesisKeyword_2_0());
                      			
                    }
                    // InternalDispatching.g:898:4: ( (lv_description_7_0= RULE_STRING ) )?
                    int alt21=2;
                    int LA21_0 = input.LA(1);

                    if ( (LA21_0==RULE_STRING) ) {
                        alt21=1;
                    }
                    switch (alt21) {
                        case 1 :
                            // InternalDispatching.g:899:5: (lv_description_7_0= RULE_STRING )
                            {
                            // InternalDispatching.g:899:5: (lv_description_7_0= RULE_STRING )
                            // InternalDispatching.g:900:6: lv_description_7_0= RULE_STRING
                            {
                            lv_description_7_0=(Token)match(input,RULE_STRING,FOLLOW_13); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(lv_description_7_0, grammarAccess.getDispatchAccess().getDescriptionSTRINGTerminalRuleCall_2_1_0());
                              					
                            }
                            if ( state.backtracking==0 ) {

                              						if (current==null) {
                              							current = createModelElement(grammarAccess.getDispatchRule());
                              						}
                              						setWithLastConsumed(
                              							current,
                              							"description",
                              							lv_description_7_0,
                              							"org.eclipse.xtext.common.Terminals.STRING");
                              					
                            }

                            }


                            }
                            break;

                    }

                    // InternalDispatching.g:916:4: ( ( (lv_userAttributes_8_0= ruleAttributesMapEntry ) ) (otherlv_9= ',' ( (lv_userAttributes_10_0= ruleAttributesMapEntry ) ) )* )?
                    int alt23=2;
                    int LA23_0 = input.LA(1);

                    if ( (LA23_0==RULE_ID) ) {
                        alt23=1;
                    }
                    switch (alt23) {
                        case 1 :
                            // InternalDispatching.g:917:5: ( (lv_userAttributes_8_0= ruleAttributesMapEntry ) ) (otherlv_9= ',' ( (lv_userAttributes_10_0= ruleAttributesMapEntry ) ) )*
                            {
                            // InternalDispatching.g:917:5: ( (lv_userAttributes_8_0= ruleAttributesMapEntry ) )
                            // InternalDispatching.g:918:6: (lv_userAttributes_8_0= ruleAttributesMapEntry )
                            {
                            // InternalDispatching.g:918:6: (lv_userAttributes_8_0= ruleAttributesMapEntry )
                            // InternalDispatching.g:919:7: lv_userAttributes_8_0= ruleAttributesMapEntry
                            {
                            if ( state.backtracking==0 ) {

                              							newCompositeNode(grammarAccess.getDispatchAccess().getUserAttributesAttributesMapEntryParserRuleCall_2_2_0_0());
                              						
                            }
                            pushFollow(FOLLOW_14);
                            lv_userAttributes_8_0=ruleAttributesMapEntry();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              							if (current==null) {
                              								current = createModelElementForParent(grammarAccess.getDispatchRule());
                              							}
                              							add(
                              								current,
                              								"userAttributes",
                              								lv_userAttributes_8_0,
                              								"org.eclipse.lsat.dispatching.teditor.Dispatching.AttributesMapEntry");
                              							afterParserOrEnumRuleCall();
                              						
                            }

                            }


                            }

                            // InternalDispatching.g:936:5: (otherlv_9= ',' ( (lv_userAttributes_10_0= ruleAttributesMapEntry ) ) )*
                            loop22:
                            do {
                                int alt22=2;
                                int LA22_0 = input.LA(1);

                                if ( (LA22_0==19) ) {
                                    alt22=1;
                                }


                                switch (alt22) {
                            	case 1 :
                            	    // InternalDispatching.g:937:6: otherlv_9= ',' ( (lv_userAttributes_10_0= ruleAttributesMapEntry ) )
                            	    {
                            	    otherlv_9=(Token)match(input,19,FOLLOW_15); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      						newLeafNode(otherlv_9, grammarAccess.getDispatchAccess().getCommaKeyword_2_2_1_0());
                            	      					
                            	    }
                            	    // InternalDispatching.g:941:6: ( (lv_userAttributes_10_0= ruleAttributesMapEntry ) )
                            	    // InternalDispatching.g:942:7: (lv_userAttributes_10_0= ruleAttributesMapEntry )
                            	    {
                            	    // InternalDispatching.g:942:7: (lv_userAttributes_10_0= ruleAttributesMapEntry )
                            	    // InternalDispatching.g:943:8: lv_userAttributes_10_0= ruleAttributesMapEntry
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      								newCompositeNode(grammarAccess.getDispatchAccess().getUserAttributesAttributesMapEntryParserRuleCall_2_2_1_1_0());
                            	      							
                            	    }
                            	    pushFollow(FOLLOW_14);
                            	    lv_userAttributes_10_0=ruleAttributesMapEntry();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      								if (current==null) {
                            	      									current = createModelElementForParent(grammarAccess.getDispatchRule());
                            	      								}
                            	      								add(
                            	      									current,
                            	      									"userAttributes",
                            	      									lv_userAttributes_10_0,
                            	      									"org.eclipse.lsat.dispatching.teditor.Dispatching.AttributesMapEntry");
                            	      								afterParserOrEnumRuleCall();
                            	      							
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop22;
                                }
                            } while (true);


                            }
                            break;

                    }

                    otherlv_11=(Token)match(input,20,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_11, grammarAccess.getDispatchAccess().getRightParenthesisKeyword_2_3());
                      			
                    }

                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleDispatch"


    // $ANTLR start "entryRuleAttributesMapEntry"
    // InternalDispatching.g:971:1: entryRuleAttributesMapEntry returns [EObject current=null] : iv_ruleAttributesMapEntry= ruleAttributesMapEntry EOF ;
    public final EObject entryRuleAttributesMapEntry() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleAttributesMapEntry = null;


        try {
            // InternalDispatching.g:971:59: (iv_ruleAttributesMapEntry= ruleAttributesMapEntry EOF )
            // InternalDispatching.g:972:2: iv_ruleAttributesMapEntry= ruleAttributesMapEntry EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getAttributesMapEntryRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleAttributesMapEntry=ruleAttributesMapEntry();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleAttributesMapEntry; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleAttributesMapEntry"


    // $ANTLR start "ruleAttributesMapEntry"
    // InternalDispatching.g:978:1: ruleAttributesMapEntry returns [EObject current=null] : ( () ( (lv_key_1_0= ruleAttribute ) ) ( ( ( ':' )=>otherlv_2= ':' ) | otherlv_3= '=' ) ( ( (lv_value_4_1= ruleIDString | lv_value_4_2= ruleINTASString ) ) ) ) ;
    public final EObject ruleAttributesMapEntry() throws RecognitionException {
        EObject current = null;

        Token otherlv_2=null;
        Token otherlv_3=null;
        EObject lv_key_1_0 = null;

        AntlrDatatypeRuleToken lv_value_4_1 = null;

        AntlrDatatypeRuleToken lv_value_4_2 = null;



        	enterRule();

        try {
            // InternalDispatching.g:984:2: ( ( () ( (lv_key_1_0= ruleAttribute ) ) ( ( ( ':' )=>otherlv_2= ':' ) | otherlv_3= '=' ) ( ( (lv_value_4_1= ruleIDString | lv_value_4_2= ruleINTASString ) ) ) ) )
            // InternalDispatching.g:985:2: ( () ( (lv_key_1_0= ruleAttribute ) ) ( ( ( ':' )=>otherlv_2= ':' ) | otherlv_3= '=' ) ( ( (lv_value_4_1= ruleIDString | lv_value_4_2= ruleINTASString ) ) ) )
            {
            // InternalDispatching.g:985:2: ( () ( (lv_key_1_0= ruleAttribute ) ) ( ( ( ':' )=>otherlv_2= ':' ) | otherlv_3= '=' ) ( ( (lv_value_4_1= ruleIDString | lv_value_4_2= ruleINTASString ) ) ) )
            // InternalDispatching.g:986:3: () ( (lv_key_1_0= ruleAttribute ) ) ( ( ( ':' )=>otherlv_2= ':' ) | otherlv_3= '=' ) ( ( (lv_value_4_1= ruleIDString | lv_value_4_2= ruleINTASString ) ) )
            {
            // InternalDispatching.g:986:3: ()
            // InternalDispatching.g:987:4: 
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getAttributesMapEntryAccess().getAttributesMapEntryAction_0(),
              					current);
              			
            }

            }

            // InternalDispatching.g:993:3: ( (lv_key_1_0= ruleAttribute ) )
            // InternalDispatching.g:994:4: (lv_key_1_0= ruleAttribute )
            {
            // InternalDispatching.g:994:4: (lv_key_1_0= ruleAttribute )
            // InternalDispatching.g:995:5: lv_key_1_0= ruleAttribute
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getAttributesMapEntryAccess().getKeyAttributeParserRuleCall_1_0());
              				
            }
            pushFollow(FOLLOW_27);
            lv_key_1_0=ruleAttribute();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getAttributesMapEntryRule());
              					}
              					set(
              						current,
              						"key",
              						lv_key_1_0,
              						"org.eclipse.lsat.dispatching.teditor.Dispatching.Attribute");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            // InternalDispatching.g:1012:3: ( ( ( ':' )=>otherlv_2= ':' ) | otherlv_3= '=' )
            int alt25=2;
            int LA25_0 = input.LA(1);

            if ( (LA25_0==14) && (synpred2_InternalDispatching())) {
                alt25=1;
            }
            else if ( (LA25_0==27) ) {
                alt25=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 25, 0, input);

                throw nvae;
            }
            switch (alt25) {
                case 1 :
                    // InternalDispatching.g:1013:4: ( ( ':' )=>otherlv_2= ':' )
                    {
                    // InternalDispatching.g:1013:4: ( ( ':' )=>otherlv_2= ':' )
                    // InternalDispatching.g:1014:5: ( ':' )=>otherlv_2= ':'
                    {
                    otherlv_2=(Token)match(input,14,FOLLOW_28); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_2, grammarAccess.getAttributesMapEntryAccess().getColonKeyword_2_0());
                      				
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalDispatching.g:1021:4: otherlv_3= '='
                    {
                    otherlv_3=(Token)match(input,27,FOLLOW_28); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_3, grammarAccess.getAttributesMapEntryAccess().getEqualsSignKeyword_2_1());
                      			
                    }

                    }
                    break;

            }

            // InternalDispatching.g:1026:3: ( ( (lv_value_4_1= ruleIDString | lv_value_4_2= ruleINTASString ) ) )
            // InternalDispatching.g:1027:4: ( (lv_value_4_1= ruleIDString | lv_value_4_2= ruleINTASString ) )
            {
            // InternalDispatching.g:1027:4: ( (lv_value_4_1= ruleIDString | lv_value_4_2= ruleINTASString ) )
            // InternalDispatching.g:1028:5: (lv_value_4_1= ruleIDString | lv_value_4_2= ruleINTASString )
            {
            // InternalDispatching.g:1028:5: (lv_value_4_1= ruleIDString | lv_value_4_2= ruleINTASString )
            int alt26=2;
            int LA26_0 = input.LA(1);

            if ( ((LA26_0>=RULE_ID && LA26_0<=RULE_STRING)) ) {
                alt26=1;
            }
            else if ( (LA26_0==RULE_INT) ) {
                alt26=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 26, 0, input);

                throw nvae;
            }
            switch (alt26) {
                case 1 :
                    // InternalDispatching.g:1029:6: lv_value_4_1= ruleIDString
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getAttributesMapEntryAccess().getValueIDStringParserRuleCall_3_0_0());
                      					
                    }
                    pushFollow(FOLLOW_2);
                    lv_value_4_1=ruleIDString();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getAttributesMapEntryRule());
                      						}
                      						set(
                      							current,
                      							"value",
                      							lv_value_4_1,
                      							"org.eclipse.lsat.dispatching.teditor.Dispatching.IDString");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }
                    break;
                case 2 :
                    // InternalDispatching.g:1045:6: lv_value_4_2= ruleINTASString
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getAttributesMapEntryAccess().getValueINTASStringParserRuleCall_3_0_1());
                      					
                    }
                    pushFollow(FOLLOW_2);
                    lv_value_4_2=ruleINTASString();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getAttributesMapEntryRule());
                      						}
                      						set(
                      							current,
                      							"value",
                      							lv_value_4_2,
                      							"org.eclipse.lsat.dispatching.teditor.Dispatching.INTASString");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }
                    break;

            }


            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleAttributesMapEntry"


    // $ANTLR start "entryRuleImport"
    // InternalDispatching.g:1067:1: entryRuleImport returns [EObject current=null] : iv_ruleImport= ruleImport EOF ;
    public final EObject entryRuleImport() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleImport = null;


        try {
            // InternalDispatching.g:1067:47: (iv_ruleImport= ruleImport EOF )
            // InternalDispatching.g:1068:2: iv_ruleImport= ruleImport EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getImportRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleImport=ruleImport();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleImport; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleImport"


    // $ANTLR start "ruleImport"
    // InternalDispatching.g:1074:1: ruleImport returns [EObject current=null] : ( () otherlv_1= 'import' ( (lv_importURI_2_0= RULE_STRING ) ) ) ;
    public final EObject ruleImport() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token lv_importURI_2_0=null;


        	enterRule();

        try {
            // InternalDispatching.g:1080:2: ( ( () otherlv_1= 'import' ( (lv_importURI_2_0= RULE_STRING ) ) ) )
            // InternalDispatching.g:1081:2: ( () otherlv_1= 'import' ( (lv_importURI_2_0= RULE_STRING ) ) )
            {
            // InternalDispatching.g:1081:2: ( () otherlv_1= 'import' ( (lv_importURI_2_0= RULE_STRING ) ) )
            // InternalDispatching.g:1082:3: () otherlv_1= 'import' ( (lv_importURI_2_0= RULE_STRING ) )
            {
            // InternalDispatching.g:1082:3: ()
            // InternalDispatching.g:1083:4: 
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getImportAccess().getImportAction_0(),
              					current);
              			
            }

            }

            otherlv_1=(Token)match(input,28,FOLLOW_29); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_1, grammarAccess.getImportAccess().getImportKeyword_1());
              		
            }
            // InternalDispatching.g:1093:3: ( (lv_importURI_2_0= RULE_STRING ) )
            // InternalDispatching.g:1094:4: (lv_importURI_2_0= RULE_STRING )
            {
            // InternalDispatching.g:1094:4: (lv_importURI_2_0= RULE_STRING )
            // InternalDispatching.g:1095:5: lv_importURI_2_0= RULE_STRING
            {
            lv_importURI_2_0=(Token)match(input,RULE_STRING,FOLLOW_2); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					newLeafNode(lv_importURI_2_0, grammarAccess.getImportAccess().getImportURISTRINGTerminalRuleCall_2_0());
              				
            }
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElement(grammarAccess.getImportRule());
              					}
              					setWithLastConsumed(
              						current,
              						"importURI",
              						lv_importURI_2_0,
              						"org.eclipse.xtext.common.Terminals.STRING");
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleImport"


    // $ANTLR start "entryRuleEBigDecimal"
    // InternalDispatching.g:1115:1: entryRuleEBigDecimal returns [String current=null] : iv_ruleEBigDecimal= ruleEBigDecimal EOF ;
    public final String entryRuleEBigDecimal() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleEBigDecimal = null;


        try {
            // InternalDispatching.g:1115:51: (iv_ruleEBigDecimal= ruleEBigDecimal EOF )
            // InternalDispatching.g:1116:2: iv_ruleEBigDecimal= ruleEBigDecimal EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getEBigDecimalRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleEBigDecimal=ruleEBigDecimal();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleEBigDecimal.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleEBigDecimal"


    // $ANTLR start "ruleEBigDecimal"
    // InternalDispatching.g:1122:1: ruleEBigDecimal returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : ( (kw= '-' )? this_INT_1= RULE_INT (kw= '.' this_INT_3= RULE_INT )? ( (kw= 'E' | kw= 'e' ) (kw= '-' )? this_INT_7= RULE_INT )? ) ;
    public final AntlrDatatypeRuleToken ruleEBigDecimal() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;
        Token this_INT_1=null;
        Token this_INT_3=null;
        Token this_INT_7=null;


        	enterRule();

        try {
            // InternalDispatching.g:1128:2: ( ( (kw= '-' )? this_INT_1= RULE_INT (kw= '.' this_INT_3= RULE_INT )? ( (kw= 'E' | kw= 'e' ) (kw= '-' )? this_INT_7= RULE_INT )? ) )
            // InternalDispatching.g:1129:2: ( (kw= '-' )? this_INT_1= RULE_INT (kw= '.' this_INT_3= RULE_INT )? ( (kw= 'E' | kw= 'e' ) (kw= '-' )? this_INT_7= RULE_INT )? )
            {
            // InternalDispatching.g:1129:2: ( (kw= '-' )? this_INT_1= RULE_INT (kw= '.' this_INT_3= RULE_INT )? ( (kw= 'E' | kw= 'e' ) (kw= '-' )? this_INT_7= RULE_INT )? )
            // InternalDispatching.g:1130:3: (kw= '-' )? this_INT_1= RULE_INT (kw= '.' this_INT_3= RULE_INT )? ( (kw= 'E' | kw= 'e' ) (kw= '-' )? this_INT_7= RULE_INT )?
            {
            // InternalDispatching.g:1130:3: (kw= '-' )?
            int alt27=2;
            int LA27_0 = input.LA(1);

            if ( (LA27_0==29) ) {
                alt27=1;
            }
            switch (alt27) {
                case 1 :
                    // InternalDispatching.g:1131:4: kw= '-'
                    {
                    kw=(Token)match(input,29,FOLLOW_7); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current.merge(kw);
                      				newLeafNode(kw, grammarAccess.getEBigDecimalAccess().getHyphenMinusKeyword_0());
                      			
                    }

                    }
                    break;

            }

            this_INT_1=(Token)match(input,RULE_INT,FOLLOW_30); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			current.merge(this_INT_1);
              		
            }
            if ( state.backtracking==0 ) {

              			newLeafNode(this_INT_1, grammarAccess.getEBigDecimalAccess().getINTTerminalRuleCall_1());
              		
            }
            // InternalDispatching.g:1144:3: (kw= '.' this_INT_3= RULE_INT )?
            int alt28=2;
            int LA28_0 = input.LA(1);

            if ( (LA28_0==16) ) {
                alt28=1;
            }
            switch (alt28) {
                case 1 :
                    // InternalDispatching.g:1145:4: kw= '.' this_INT_3= RULE_INT
                    {
                    kw=(Token)match(input,16,FOLLOW_7); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current.merge(kw);
                      				newLeafNode(kw, grammarAccess.getEBigDecimalAccess().getFullStopKeyword_2_0());
                      			
                    }
                    this_INT_3=(Token)match(input,RULE_INT,FOLLOW_31); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current.merge(this_INT_3);
                      			
                    }
                    if ( state.backtracking==0 ) {

                      				newLeafNode(this_INT_3, grammarAccess.getEBigDecimalAccess().getINTTerminalRuleCall_2_1());
                      			
                    }

                    }
                    break;

            }

            // InternalDispatching.g:1158:3: ( (kw= 'E' | kw= 'e' ) (kw= '-' )? this_INT_7= RULE_INT )?
            int alt31=2;
            int LA31_0 = input.LA(1);

            if ( ((LA31_0>=30 && LA31_0<=31)) ) {
                alt31=1;
            }
            switch (alt31) {
                case 1 :
                    // InternalDispatching.g:1159:4: (kw= 'E' | kw= 'e' ) (kw= '-' )? this_INT_7= RULE_INT
                    {
                    // InternalDispatching.g:1159:4: (kw= 'E' | kw= 'e' )
                    int alt29=2;
                    int LA29_0 = input.LA(1);

                    if ( (LA29_0==30) ) {
                        alt29=1;
                    }
                    else if ( (LA29_0==31) ) {
                        alt29=2;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return current;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 29, 0, input);

                        throw nvae;
                    }
                    switch (alt29) {
                        case 1 :
                            // InternalDispatching.g:1160:5: kw= 'E'
                            {
                            kw=(Token)match(input,30,FOLLOW_21); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              					current.merge(kw);
                              					newLeafNode(kw, grammarAccess.getEBigDecimalAccess().getEKeyword_3_0_0());
                              				
                            }

                            }
                            break;
                        case 2 :
                            // InternalDispatching.g:1166:5: kw= 'e'
                            {
                            kw=(Token)match(input,31,FOLLOW_21); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              					current.merge(kw);
                              					newLeafNode(kw, grammarAccess.getEBigDecimalAccess().getEKeyword_3_0_1());
                              				
                            }

                            }
                            break;

                    }

                    // InternalDispatching.g:1172:4: (kw= '-' )?
                    int alt30=2;
                    int LA30_0 = input.LA(1);

                    if ( (LA30_0==29) ) {
                        alt30=1;
                    }
                    switch (alt30) {
                        case 1 :
                            // InternalDispatching.g:1173:5: kw= '-'
                            {
                            kw=(Token)match(input,29,FOLLOW_7); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              					current.merge(kw);
                              					newLeafNode(kw, grammarAccess.getEBigDecimalAccess().getHyphenMinusKeyword_3_1());
                              				
                            }

                            }
                            break;

                    }

                    this_INT_7=(Token)match(input,RULE_INT,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current.merge(this_INT_7);
                      			
                    }
                    if ( state.backtracking==0 ) {

                      				newLeafNode(this_INT_7, grammarAccess.getEBigDecimalAccess().getINTTerminalRuleCall_3_2());
                      			
                    }

                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleEBigDecimal"


    // $ANTLR start "entryRuleIDString"
    // InternalDispatching.g:1191:1: entryRuleIDString returns [String current=null] : iv_ruleIDString= ruleIDString EOF ;
    public final String entryRuleIDString() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleIDString = null;


        try {
            // InternalDispatching.g:1191:48: (iv_ruleIDString= ruleIDString EOF )
            // InternalDispatching.g:1192:2: iv_ruleIDString= ruleIDString EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getIDStringRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleIDString=ruleIDString();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleIDString.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleIDString"


    // $ANTLR start "ruleIDString"
    // InternalDispatching.g:1198:1: ruleIDString returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : (this_ID_0= RULE_ID | this_STRING_1= RULE_STRING ) ;
    public final AntlrDatatypeRuleToken ruleIDString() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token this_ID_0=null;
        Token this_STRING_1=null;


        	enterRule();

        try {
            // InternalDispatching.g:1204:2: ( (this_ID_0= RULE_ID | this_STRING_1= RULE_STRING ) )
            // InternalDispatching.g:1205:2: (this_ID_0= RULE_ID | this_STRING_1= RULE_STRING )
            {
            // InternalDispatching.g:1205:2: (this_ID_0= RULE_ID | this_STRING_1= RULE_STRING )
            int alt32=2;
            int LA32_0 = input.LA(1);

            if ( (LA32_0==RULE_ID) ) {
                alt32=1;
            }
            else if ( (LA32_0==RULE_STRING) ) {
                alt32=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 32, 0, input);

                throw nvae;
            }
            switch (alt32) {
                case 1 :
                    // InternalDispatching.g:1206:3: this_ID_0= RULE_ID
                    {
                    this_ID_0=(Token)match(input,RULE_ID,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(this_ID_0);
                      		
                    }
                    if ( state.backtracking==0 ) {

                      			newLeafNode(this_ID_0, grammarAccess.getIDStringAccess().getIDTerminalRuleCall_0());
                      		
                    }

                    }
                    break;
                case 2 :
                    // InternalDispatching.g:1214:3: this_STRING_1= RULE_STRING
                    {
                    this_STRING_1=(Token)match(input,RULE_STRING,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(this_STRING_1);
                      		
                    }
                    if ( state.backtracking==0 ) {

                      			newLeafNode(this_STRING_1, grammarAccess.getIDStringAccess().getSTRINGTerminalRuleCall_1());
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleIDString"


    // $ANTLR start "entryRuleINTASString"
    // InternalDispatching.g:1225:1: entryRuleINTASString returns [String current=null] : iv_ruleINTASString= ruleINTASString EOF ;
    public final String entryRuleINTASString() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleINTASString = null;


        try {
            // InternalDispatching.g:1225:51: (iv_ruleINTASString= ruleINTASString EOF )
            // InternalDispatching.g:1226:2: iv_ruleINTASString= ruleINTASString EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getINTASStringRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleINTASString=ruleINTASString();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleINTASString.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleINTASString"


    // $ANTLR start "ruleINTASString"
    // InternalDispatching.g:1232:1: ruleINTASString returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : this_INT_0= RULE_INT ;
    public final AntlrDatatypeRuleToken ruleINTASString() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token this_INT_0=null;


        	enterRule();

        try {
            // InternalDispatching.g:1238:2: (this_INT_0= RULE_INT )
            // InternalDispatching.g:1239:2: this_INT_0= RULE_INT
            {
            this_INT_0=(Token)match(input,RULE_INT,FOLLOW_2); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              		current.merge(this_INT_0);
              	
            }
            if ( state.backtracking==0 ) {

              		newLeafNode(this_INT_0, grammarAccess.getINTASStringAccess().getINTTerminalRuleCall());
              	
            }

            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleINTASString"


    // $ANTLR start "entryRuleIID"
    // InternalDispatching.g:1249:1: entryRuleIID returns [String current=null] : iv_ruleIID= ruleIID EOF ;
    public final String entryRuleIID() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleIID = null;


        try {
            // InternalDispatching.g:1249:43: (iv_ruleIID= ruleIID EOF )
            // InternalDispatching.g:1250:2: iv_ruleIID= ruleIID EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getIIDRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleIID=ruleIID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleIID.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleIID"


    // $ANTLR start "ruleIID"
    // InternalDispatching.g:1256:1: ruleIID returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : (this_INT_0= RULE_INT | this_ID_1= RULE_ID ) ;
    public final AntlrDatatypeRuleToken ruleIID() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token this_INT_0=null;
        Token this_ID_1=null;


        	enterRule();

        try {
            // InternalDispatching.g:1262:2: ( (this_INT_0= RULE_INT | this_ID_1= RULE_ID ) )
            // InternalDispatching.g:1263:2: (this_INT_0= RULE_INT | this_ID_1= RULE_ID )
            {
            // InternalDispatching.g:1263:2: (this_INT_0= RULE_INT | this_ID_1= RULE_ID )
            int alt33=2;
            int LA33_0 = input.LA(1);

            if ( (LA33_0==RULE_INT) ) {
                alt33=1;
            }
            else if ( (LA33_0==RULE_ID) ) {
                alt33=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 33, 0, input);

                throw nvae;
            }
            switch (alt33) {
                case 1 :
                    // InternalDispatching.g:1264:3: this_INT_0= RULE_INT
                    {
                    this_INT_0=(Token)match(input,RULE_INT,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(this_INT_0);
                      		
                    }
                    if ( state.backtracking==0 ) {

                      			newLeafNode(this_INT_0, grammarAccess.getIIDAccess().getINTTerminalRuleCall_0());
                      		
                    }

                    }
                    break;
                case 2 :
                    // InternalDispatching.g:1272:3: this_ID_1= RULE_ID
                    {
                    this_ID_1=(Token)match(input,RULE_ID,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(this_ID_1);
                      		
                    }
                    if ( state.backtracking==0 ) {

                      			newLeafNode(this_ID_1, grammarAccess.getIIDAccess().getIDTerminalRuleCall_1());
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleIID"


    // $ANTLR start "entryRuleResourceQualifiedName"
    // InternalDispatching.g:1283:1: entryRuleResourceQualifiedName returns [String current=null] : iv_ruleResourceQualifiedName= ruleResourceQualifiedName EOF ;
    public final String entryRuleResourceQualifiedName() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleResourceQualifiedName = null;


        try {
            // InternalDispatching.g:1283:61: (iv_ruleResourceQualifiedName= ruleResourceQualifiedName EOF )
            // InternalDispatching.g:1284:2: iv_ruleResourceQualifiedName= ruleResourceQualifiedName EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getResourceQualifiedNameRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleResourceQualifiedName=ruleResourceQualifiedName();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleResourceQualifiedName.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleResourceQualifiedName"


    // $ANTLR start "ruleResourceQualifiedName"
    // InternalDispatching.g:1290:1: ruleResourceQualifiedName returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : (this_IID_0= ruleIID (kw= '.' this_IID_2= ruleIID )? ) ;
    public final AntlrDatatypeRuleToken ruleResourceQualifiedName() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;
        AntlrDatatypeRuleToken this_IID_0 = null;

        AntlrDatatypeRuleToken this_IID_2 = null;



        	enterRule();

        try {
            // InternalDispatching.g:1296:2: ( (this_IID_0= ruleIID (kw= '.' this_IID_2= ruleIID )? ) )
            // InternalDispatching.g:1297:2: (this_IID_0= ruleIID (kw= '.' this_IID_2= ruleIID )? )
            {
            // InternalDispatching.g:1297:2: (this_IID_0= ruleIID (kw= '.' this_IID_2= ruleIID )? )
            // InternalDispatching.g:1298:3: this_IID_0= ruleIID (kw= '.' this_IID_2= ruleIID )?
            {
            if ( state.backtracking==0 ) {

              			newCompositeNode(grammarAccess.getResourceQualifiedNameAccess().getIIDParserRuleCall_0());
              		
            }
            pushFollow(FOLLOW_32);
            this_IID_0=ruleIID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			current.merge(this_IID_0);
              		
            }
            if ( state.backtracking==0 ) {

              			afterParserOrEnumRuleCall();
              		
            }
            // InternalDispatching.g:1308:3: (kw= '.' this_IID_2= ruleIID )?
            int alt34=2;
            int LA34_0 = input.LA(1);

            if ( (LA34_0==16) ) {
                alt34=1;
            }
            switch (alt34) {
                case 1 :
                    // InternalDispatching.g:1309:4: kw= '.' this_IID_2= ruleIID
                    {
                    kw=(Token)match(input,16,FOLLOW_10); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current.merge(kw);
                      				newLeafNode(kw, grammarAccess.getResourceQualifiedNameAccess().getFullStopKeyword_1_0());
                      			
                    }
                    if ( state.backtracking==0 ) {

                      				newCompositeNode(grammarAccess.getResourceQualifiedNameAccess().getIIDParserRuleCall_1_1());
                      			
                    }
                    pushFollow(FOLLOW_2);
                    this_IID_2=ruleIID();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current.merge(this_IID_2);
                      			
                    }
                    if ( state.backtracking==0 ) {

                      				afterParserOrEnumRuleCall();
                      			
                    }

                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleResourceQualifiedName"


    // $ANTLR start "entryRuleResourceItemQualifiedName"
    // InternalDispatching.g:1329:1: entryRuleResourceItemQualifiedName returns [String current=null] : iv_ruleResourceItemQualifiedName= ruleResourceItemQualifiedName EOF ;
    public final String entryRuleResourceItemQualifiedName() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleResourceItemQualifiedName = null;


        try {
            // InternalDispatching.g:1329:65: (iv_ruleResourceItemQualifiedName= ruleResourceItemQualifiedName EOF )
            // InternalDispatching.g:1330:2: iv_ruleResourceItemQualifiedName= ruleResourceItemQualifiedName EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getResourceItemQualifiedNameRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleResourceItemQualifiedName=ruleResourceItemQualifiedName();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleResourceItemQualifiedName.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleResourceItemQualifiedName"


    // $ANTLR start "ruleResourceItemQualifiedName"
    // InternalDispatching.g:1336:1: ruleResourceItemQualifiedName returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : (this_IID_0= ruleIID (kw= '.' this_IID_2= ruleIID )? ) ;
    public final AntlrDatatypeRuleToken ruleResourceItemQualifiedName() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;
        AntlrDatatypeRuleToken this_IID_0 = null;

        AntlrDatatypeRuleToken this_IID_2 = null;



        	enterRule();

        try {
            // InternalDispatching.g:1342:2: ( (this_IID_0= ruleIID (kw= '.' this_IID_2= ruleIID )? ) )
            // InternalDispatching.g:1343:2: (this_IID_0= ruleIID (kw= '.' this_IID_2= ruleIID )? )
            {
            // InternalDispatching.g:1343:2: (this_IID_0= ruleIID (kw= '.' this_IID_2= ruleIID )? )
            // InternalDispatching.g:1344:3: this_IID_0= ruleIID (kw= '.' this_IID_2= ruleIID )?
            {
            if ( state.backtracking==0 ) {

              			newCompositeNode(grammarAccess.getResourceItemQualifiedNameAccess().getIIDParserRuleCall_0());
              		
            }
            pushFollow(FOLLOW_32);
            this_IID_0=ruleIID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			current.merge(this_IID_0);
              		
            }
            if ( state.backtracking==0 ) {

              			afterParserOrEnumRuleCall();
              		
            }
            // InternalDispatching.g:1354:3: (kw= '.' this_IID_2= ruleIID )?
            int alt35=2;
            int LA35_0 = input.LA(1);

            if ( (LA35_0==16) ) {
                alt35=1;
            }
            switch (alt35) {
                case 1 :
                    // InternalDispatching.g:1355:4: kw= '.' this_IID_2= ruleIID
                    {
                    kw=(Token)match(input,16,FOLLOW_10); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current.merge(kw);
                      				newLeafNode(kw, grammarAccess.getResourceItemQualifiedNameAccess().getFullStopKeyword_1_0());
                      			
                    }
                    if ( state.backtracking==0 ) {

                      				newCompositeNode(grammarAccess.getResourceItemQualifiedNameAccess().getIIDParserRuleCall_1_1());
                      			
                    }
                    pushFollow(FOLLOW_2);
                    this_IID_2=ruleIID();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current.merge(this_IID_2);
                      			
                    }
                    if ( state.backtracking==0 ) {

                      				afterParserOrEnumRuleCall();
                      			
                    }

                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleResourceItemQualifiedName"

    // $ANTLR start synpred1_InternalDispatching
    public final void synpred1_InternalDispatching_fragment() throws RecognitionException {   
        // InternalDispatching.g:393:6: ( ( ruleNumberRepeats ) )
        // InternalDispatching.g:393:7: ( ruleNumberRepeats )
        {
        // InternalDispatching.g:393:7: ( ruleNumberRepeats )
        // InternalDispatching.g:394:7: ruleNumberRepeats
        {
        pushFollow(FOLLOW_2);
        ruleNumberRepeats();

        state._fsp--;
        if (state.failed) return ;

        }


        }
    }
    // $ANTLR end synpred1_InternalDispatching

    // $ANTLR start synpred2_InternalDispatching
    public final void synpred2_InternalDispatching_fragment() throws RecognitionException {   
        // InternalDispatching.g:1014:5: ( ':' )
        // InternalDispatching.g:1014:6: ':'
        {
        match(input,14,FOLLOW_2); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred2_InternalDispatching

    // Delegated rules

    public final boolean synpred1_InternalDispatching() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred1_InternalDispatching_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred2_InternalDispatching() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred2_InternalDispatching_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }


 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x0000000010020802L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x000000000000A000L});
    public static final BitSet FOLLOW_6 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_7 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_8 = new BitSet(new long[]{0x0000000000020002L});
    public static final BitSet FOLLOW_9 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_10 = new BitSet(new long[]{0x0000000000000030L});
    public static final BitSet FOLLOW_11 = new BitSet(new long[]{0x0000000000241060L});
    public static final BitSet FOLLOW_12 = new BitSet(new long[]{0x0000000000241000L});
    public static final BitSet FOLLOW_13 = new BitSet(new long[]{0x0000000000100020L});
    public static final BitSet FOLLOW_14 = new BitSet(new long[]{0x0000000000180000L});
    public static final BitSet FOLLOW_15 = new BitSet(new long[]{0x0000000000000020L});
    public static final BitSet FOLLOW_16 = new BitSet(new long[]{0x0000000000201000L});
    public static final BitSet FOLLOW_17 = new BitSet(new long[]{0x0000000000004060L});
    public static final BitSet FOLLOW_18 = new BitSet(new long[]{0x0000000000400010L});
    public static final BitSet FOLLOW_19 = new BitSet(new long[]{0x0000000000880000L});
    public static final BitSet FOLLOW_20 = new BitSet(new long[]{0x0000000003008020L});
    public static final BitSet FOLLOW_21 = new BitSet(new long[]{0x0000000020000010L});
    public static final BitSet FOLLOW_22 = new BitSet(new long[]{0x0000000000008020L});
    public static final BitSet FOLLOW_23 = new BitSet(new long[]{0x0000000004000000L});
    public static final BitSet FOLLOW_24 = new BitSet(new long[]{0x0000000000440002L});
    public static final BitSet FOLLOW_25 = new BitSet(new long[]{0x0000000000040002L});
    public static final BitSet FOLLOW_26 = new BitSet(new long[]{0x0000000000100060L});
    public static final BitSet FOLLOW_27 = new BitSet(new long[]{0x0000000008004000L});
    public static final BitSet FOLLOW_28 = new BitSet(new long[]{0x0000000000000070L});
    public static final BitSet FOLLOW_29 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_30 = new BitSet(new long[]{0x00000000C0010002L});
    public static final BitSet FOLLOW_31 = new BitSet(new long[]{0x00000000C0000002L});
    public static final BitSet FOLLOW_32 = new BitSet(new long[]{0x0000000000010002L});

}